/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.data;

import java.util.Hashtable;
import java.util.Set;

/**
 * @author sschaffe
 *
 */
public class RequestData {

	private Hashtable<String,String> stringData;
	private Hashtable<String,String[]> listData;
	private Hashtable<String,byte[]> byteData;
	
	/**
	 * 
	 */
	public RequestData() {
		super();
		
		stringData = new Hashtable<String,String>();
		listData = new Hashtable<String,String[]>();
		byteData   = new Hashtable<String,byte[]>();
	}

	
	
	public Set<String> keySet() {
		return stringData.keySet();
	}



	public boolean containsKey(Object key) {
		return stringData.containsKey(key);
	}

	public String get(String key) {
		return stringData.get(key);
	}

	public String put(String key, String value) {
		putList(key,value);
		return stringData.put(key, value);
	}
	
	public boolean containsBytesKey(String key) {
		return byteData.containsKey(key);
	}
	
	
	public byte[] getBytes(String key) {
		return byteData.get(key);
	}
	
	public void putBytes(String key, byte[] value) {
		byteData.put(key,value);
	}

	
	public String[] getList(String key) {
		return listData.get(key);
	}
	
	public void putList(String key, String value) {
		String[] nval;
		String[] val = listData.get(key);
		if(val != null) {
			nval = new String[val.length+1];
			for(int i=0;i<val.length;i++) {
				nval[i] = val[i];
			}
		} else {
			nval = new String[1];
		}
		nval[nval.length-1] = value;
		listData.put(key,nval);
	}
	
	
	public Hashtable<String, byte[]> getByteData() {
		return byteData;
	}


	public Hashtable<String, String> getStringData() {
		return stringData;
	}

	
	
}
