/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.data;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

/**
 * @author sschaffe
 *
 */
public class SessionHistory implements Iterable<WikiResource> {

	public static final int HISTORY_SIZE = 10;
	
	private List<WikiResource> history;
	
	/**
	 * 
	 */
	public SessionHistory() {
		super();
		
		history = new LinkedList<WikiResource>();
	}

	public void addHistory(WikiResource r) {
		if(history.size() == 0 || !(history.get(0).equals(r))) {
			history.remove(r);			
			history.add(0,r);
			
			while(history.size() > HISTORY_SIZE) {
				history.remove(history.size()-1);
			}
		}
	}
	
	public List<WikiResource> getHistory() {
		return new ArrayList<WikiResource>(history);
	}
	
	
	
	
	public int size() {
		return history.size();		
	}

	public Iterator<WikiResource> iterator() {
		return history.iterator();
	}
	
	
	public WikiResource first() {
		if(history.size() > 0) {
			return history.get(0);
		} else {
			return null;
		}
	}
	
}
