/**
 *  Copyright (C) 2006
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 *
 *  File: WikiAnonResource.java
 *
 */

package at.srfg.ikewiki.data;

import com.hp.hpl.jena.rdf.model.AnonId;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;

/**
 * @author sschaffe
 *
 * TODO
 *
 */
public class WikiAnonResource implements WikiNode {

	private String id;
	
	/**
	 * 
	 */
	public WikiAnonResource(String id) {
		super();
		this.id = id;
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.data.WikiNode#isResource()
	 */
	public boolean isResource() {
		return false;
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.data.WikiNode#isLiteral()
	 */
	public boolean isLiteral() {
		return false;
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.data.WikiNode#isAnonymous()
	 */
	public boolean isAnonymous() {
		return true;
	}

	
	
	public String getId() {
		return id;
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.data.WikiNode#toJenaNode(com.hp.hpl.jena.rdf.model.Model)
	 */
	public RDFNode toJenaNode(Model m) {
		return toJenaResource(m);
	}

	public Resource toJenaResource(Model m) {
		return m.createResource(AnonId.create(this.id));
	}
	
	public String toString() {
		return "Anonymous Node "+getId();
	}
	
	public int compareTo(WikiNode o) {
		if(o instanceof WikiAnonResource) {
			return getId().compareTo(((WikiAnonResource)o).getId());
		} else {
			return 1; // anonymous nodes are last
		}
	}
	
}
