/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.db;

import at.srfg.ikewiki.data.WikiResource;

/**
 * @author sschaffe
 *
 */
public interface ResourceChangeListener {

	/**
	 * Notify all listeners that a wikiresource is affected by a change.
	 * @param r
	 */
	public void changeEvent(WikiResource r);
	
	/**
	 * Notify all listeners to expect everything to be changed
	 * 
	 * This currently happens when an image is uploaded and all caches need to be flushed
	 *
	 */
	public void allChangeEvent();
}
