/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.editing.templates;

import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.data.Namespace;
import at.srfg.ikewiki.data.WikiResource;
import at.srfg.ikewiki.db.DBException;

/**
 * @author sschaffe
 *
 */
public class ClassTemplate extends Template {

	private static Log log = LogFactory.getLog(ClassTemplate.class);

	/**
	 * @param main
	 */
	public ClassTemplate(Main main) {
		super(main);
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.editing.templates.Template#getName()
	 */
	@Override
	public String getName() {
		return "Class";
	}

	@Override
	public String getUri() {
		return Namespace.NS_OWL+"Class";
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.editing.templates.Template#getTemplateText(at.srfg.ikewiki.data.WikiResource)
	 */
	@Override
	public String getTemplateText(WikiResource r) {
		return "== Description ==\n\n(fill in the description here)";
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.editing.templates.Template#applyTemplateRules(at.srfg.ikewiki.data.WikiResource)
	 */
	@Override
	public void applyTemplateRules(WikiResource r, Map<String,String> parameters) {
		try {
			main.getStorageBackend().storeType(r,main.getResourceByUri(Namespace.NS_OWL+"Class"));
		} catch(DBException ex) {
			log.error("error setting type",ex);
		}
	}

}
