/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.editing.templates;

import java.util.Map;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.data.Namespace;
import at.srfg.ikewiki.data.WikiResource;

/**
 * @author sschaffe
 *
 */
public class ResourceTemplate extends Template {

	/**
	 * 
	 */
	public ResourceTemplate(Main main) {
		super(main);
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.editing.templates.Template#getName()
	 */
	public String getName() {
		return "Resource";
	}
	
	
	@Override
	public String getUri() {
		return Namespace.NS_RDFS+"Resource";
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.editing.templates.Template#getTemplateText(at.srfg.ikewiki.data.WikiResource)
	 */
	public String getTemplateText(WikiResource r) {
		return "";
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.editing.templates.Template#applyTemplateRules(at.srfg.ikewiki.data.WikiResource)
	 */
	public void applyTemplateRules(WikiResource r , Map<String,String> parameters) {
		// don't need to do anything for resources
	}

}
