/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.layout.perspectives;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.data.Article;


/**
 * @author sschaffe
 *
 */
public class EditContentPerspective extends ViewArticlePerspective {

	/**
	 * 
	 */
	public EditContentPerspective(Main main, Article a) {
		super(main,a);
	}

	private String escapeHTML(CharSequence raw_text) {
		String result;
		result = raw_text.toString().replace("&","&amp;");
		result = result.replace("<","&lt;");
		result = result.replace(">","&gt;");
		
		return result;
	}

	
	@Override
	public String getTitlePrefix() {
		return "Editing Content: ";
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.render.Perspective#getContent()
	 */
	@Override
	public String getContent() {		
		return escapeHTML(article.getText());
	}
	
	public ViewArticlePerspective getPreview() {
		return new ViewArticlePerspective(main,this.getArticle());
	}
}
