/**
 * 
 */
package at.srfg.ikewiki.layout.perspectives;

import java.net.URISyntaxException;
import java.util.Collections;
import java.util.Date;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.data.Article;
import at.srfg.ikewiki.data.Namespace;
import at.srfg.ikewiki.db.DBException;
import at.srfg.ikewiki.render.RenderingException;

/**
 * @author sschaffe
 *
 */
public class EditFormPerspective extends ViewArticlePerspective {

	private static Log log = LogFactory.getLog(EditFormPerspective.class);

	private String formContent;
	
	/**
	 * @param main
	 * @param a
	 */
	public EditFormPerspective(Main main, Article a) {
		super(main, a);
		
		try {
			formContent = engine.transformForm(a);
		} catch(RenderingException ex) {
			formContent = "<div id=\"content\"><h1 class=\"firstHeading\">"+a.getTitle()+" (rendering error)</h1><div id=\"bodyContent\"><div class=\"error\">An error occurred while rendering this page. Please change the content <a href=\"index.jsp?action=edit_content&amp;title="+Main.encodeURL(a.getQualifiedTitle())+"\">here</a>.<br /><br /><strong>Error Message:</strong> "+Main.encodeXML(ex.getMessage())+"</div></div></div>";
			log.error("rendering error",ex);
		}
	}

	/**
	 * @param main
	 * @param namespace
	 * @param title
	 * @throws URISyntaxException
	 */
	public EditFormPerspective(Main main, Namespace namespace, String title) 	throws URISyntaxException {
		this(main,new Article(namespace,title,"","Sample Text","en","http://ikewiki.srfg.at/Special:"+title,new Date())); 
	}

	/**
	 * @param main
	 * @param namespace
	 * @param title
	 * @param text
	 * @throws URISyntaxException
	 */
	public EditFormPerspective(Main main, Namespace namespace, String title, 	String text) throws URISyntaxException {
		this(main,new Article(namespace,title,"",text,"en","http://ikewiki.srfg.at/Special:"+title,new Date())); 		
	}

	@Override
	public String getContent() {
		return formContent;
	}

	
}
