/**
 *  Copyright (C) 2006
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.layout.perspectives;

import java.net.URISyntaxException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.data.Article;
import at.srfg.ikewiki.data.Namespace;
import at.srfg.ikewiki.render.RenderingException;

/**
 * @author sschaffe
 *
 */
public class EditMozilePerspective extends ViewArticlePerspective implements Perspective {

	private static Log log = LogFactory.getLog(ViewArticlePerspective.class);

	/**
	 * @param main
	 * @param a
	 */
	public EditMozilePerspective(Main main, Article a) {
		super(main, a);
	}

	/**
	 * @param main
	 * @param namespace
	 * @param title
	 * @throws URISyntaxException
	 */
	public EditMozilePerspective(Main main, Namespace namespace, String title) throws URISyntaxException {
		super(main, namespace, title);
	}

	/**
	 * @param main
	 * @param namespace
	 * @param title
	 * @param text
	 * @throws URISyntaxException
	 */
	public EditMozilePerspective(Main main, Namespace namespace, String title, String text) throws URISyntaxException {
		super(main, namespace, title, text);
	}
	
	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.render.Perspective#toHTML()
	 */
	public String getContent() {
		try {
			return engine.transformMozile(article);
		} catch(RenderingException ex) {
			log.error("rendering error",ex);
			return "<div id=\"content\"><h1 class=\"firstHeading\">"+article.getTitle()+" (rendering error)</h1><div id=\"bodyContent\"><div class=\"error\">An error occurred while rendering this page. Please change the content <a href=\"index.jsp?action=edit_content&amp;title="+Main.encodeURL(article.getQualifiedTitle())+"\">here</a>.<br /><br /><strong>Error Message:</strong> "+Main.encodeXML(ex.getMessage())+"</div></div></div>";
		}
	}


}
