/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.layout.perspectives;

import java.util.Iterator;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.actions.Action;

public class LoginPerspective extends BasePerspective {

	private boolean authenticated;
	
	public LoginPerspective(Main m) {
		super(m);
	}

	public String getTitle() {
		return "Create Account / Log In";
	}

	public String getLocalTitle() {
		return "Login";
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.layout.perspectives.Perspective#getActions()
	 */
	public Iterable<Action> getActions() {
		return new Iterable<Action> () {

			public Iterator<Action> iterator() {
				return new Iterator<Action>() {
					
					boolean retrieved = false;
					
					public boolean hasNext() {
						return !retrieved;
					}

					/* (non-Javadoc)
					 * @see java.util.Iterator#next()
					 */
					public Action next() {
						retrieved = true;
						return main.getAction("login");
					}

					/* (non-Javadoc)
					 * @see java.util.Iterator#remove()
					 */
					public void remove() {
						// TODO Auto-generated method stub
						
					}
					
				};
			}
			
		};
	}

	public boolean isAuthenticated() {
		return authenticated;
	}

	public void setAuthenticated(boolean authenticated) {
		this.authenticated = authenticated;
	}

	

}
