/**
 * 
 */
package at.srfg.ikewiki.layout.perspectives;

import java.util.Iterator;
import java.util.List;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.actions.Action;
import at.srfg.ikewiki.data.Article;
import at.srfg.ikewiki.db.DBException;
import at.srfg.ikewiki.render.RenderingException;

/**
 * @author wastl
 *
 */
public class RecentChangesPerspective extends BasePerspective {

	/**
	 * @param m
	 */
	public RecentChangesPerspective(Main m) {
		super(m);
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.layout.perspectives.BasePerspective#getTitle()
	 */
	@Override
	public String getTitle() {
		return "Recent Changes";
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.layout.perspectives.BasePerspective#getLocalTitle()
	 */
	@Override
	protected String getLocalTitle() {
		return "RecentChanges";
	}

	public List<Article> getRecentChanges(int limit, int offset) throws DBException {
		return main.getStorageBackend().listRecentChanges(limit,offset);
	}

	
	public String getPreview(Article a)  {
		try {
			return main.getRenderingPipeline().transformRecentChangesResult(a);
		} catch(RenderingException ex) {
			return "<div class=\"search-preview preview-error\">error rendering preview of this article</div>\n";
		}
	}

	
	
	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.layout.perspectives.Perspective#getActions()
	 */
	public Iterable<Action> getActions() {
		return new Iterable<Action> () {

			public Iterator<Action> iterator() {
				return new Iterator<Action>() {
					
					boolean retrieved = false;
					
					public boolean hasNext() {
						return !retrieved;
					}

					public Action next() {
						retrieved = true;
						return main.getAction("recent");
					}

					public void remove() {
						throw new UnsupportedOperationException();						
					}
					
				};
			}
		};
	}

}
