/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.layout.perspectives;

import java.io.IOException;
import java.util.Collections;

import javax.servlet.http.HttpServletResponse;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.actions.Action;
import at.srfg.ikewiki.db.DBException;

public class RedirectPerspective extends BasePerspective {

	private String url;
	
	public RedirectPerspective(Main m, String url) {
		super(m);
		this.url = url;
	}

	@Override
	public String getTitle() {
		return "Redirect";
	}

	@Override
	protected String getLocalTitle() {
		return "Redirect";
	}

	public Iterable<Action> getActions() {
		return Collections.emptyList();
	}
	
	public void performRedirect(HttpServletResponse response) throws DBException {
		try {
			response.sendRedirect(this.url);
		} catch(IOException ex) {
			throw new DBException("error while redirecting to "+url,ex);
		}		
	}

}
