/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.layout.perspectives;

import java.util.Collections;
import java.util.Iterator;
import java.util.SortedSet;
import java.util.TreeSet;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.actions.Action;
import at.srfg.ikewiki.data.WikiLink;
import at.srfg.ikewiki.data.WikiResource;
import at.srfg.ikewiki.db.DBException;

/**
 * @author sschaffe
 *
 */
public class RelatedPerspective extends BasePerspective implements Perspective {

	private WikiResource context;
	
	/**
	 * @param m
	 */
	public RelatedPerspective(Main m, WikiResource context) {
		super(m);
		this.context = context;
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.layout.perspectives.BasePerspective#getTitle()
	 */
	@Override
	public String getTitle() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.layout.perspectives.BasePerspective#getLocalTitle()
	 */
	@Override
	protected String getLocalTitle() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.layout.perspectives.Perspective#getActions()
	 */
	public Iterable<Action> getActions() {
		return new Iterable<Action> () {

			public Iterator<Action> iterator() {
				return new Iterator<Action>() {
					
					boolean retrieved = false;
					
					public boolean hasNext() {
						return !retrieved;
					}

					public Action next() {
						retrieved = true;
						return main.getAction("related");
					}

					public void remove() {
						throw new UnsupportedOperationException();
					}
					
				};
			}
		};
	}

	
	public Iterable<WikiResource> getRelatedByType() throws DBException {
		// use a sorted set as container so results are ordered lexically ...
		SortedSet<WikiResource> results = new TreeSet<WikiResource>();
		
		for(WikiResource type :  main.getStorageBackend().getDirectTypes(context)) {
			for(WikiResource individual : main.getStorageBackend().getInstances(type)) {
				results.add(individual);
			}
		}
		
		return results;
	}
	
	
	public Iterable<WikiLink> getRelatedByIncomingLink() throws DBException {
		return main.getStorageBackend().getTriplesByObject(context);
	}
	
	public Iterable<WikiLink> getRelatedByOutgoingLink() throws DBException {
		return main.getStorageBackend().getTriplesBySubject(context);
	}
	
	public Iterable<WikiResource> getRelatedByNamespace() throws DBException {
		return Collections.emptyList();
	}
}
