/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.layout.perspectives;

import java.util.Iterator;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.actions.Action;

/**
 * @author sschaffe
 *
 */
public class VariablesPerspective extends BasePerspective {

	/**
	 * @param m
	 */
	public VariablesPerspective(Main m) {
		super(m);
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.render.BasePerspective#getTitle()
	 */
	@Override
	public String getTitle() {
		return "Editing Variables";
	}

	
	
	@Override
	public String getContentType() {
		return "text/html";
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.render.BasePerspective#getLocalTitle()
	 */
	@Override
	protected String getLocalTitle() {
		return "EditVariables";
	}

	public Iterable<Action> getActions() {
		return new Iterable<Action> () {

			public Iterator<Action> iterator() {
				return new Iterator<Action>() {
					
					boolean retrieved = false;
					
					public boolean hasNext() {
						return !retrieved;
					}

					public Action next() {
						retrieved = true;
						return main.getAction("variables");
					}

					public void remove() {
						throw new UnsupportedOperationException();						
					}
					
				};
			}
		};
	}

}
