/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.layout.views;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.data.WikiResource;
import at.srfg.ikewiki.layout.perspectives.Perspective;
import at.srfg.ikewiki.layout.perspectives.ViewArticlePerspective;
import at.srfg.ikewiki.render.RenderingException;

/**
 * @author wastl
 *
 */
public class ReferencesView extends View {

	/**
	 * @param main
	 */
	public ReferencesView(Main main) {
		super(main);
		// TODO Auto-generated constructor stub
	}


	
	
	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.layout.views.View#getType()
	 */
	@Override
	public TYPES getType() {
		return TYPES.PORTLET_RIGHT;
	}




	/**
	 * ReferencesView considers itself responsible for everything.
	 * 
	 * @see at.srfg.ikewiki.layout.views.View#responsibleFor(at.srfg.ikewiki.data.WikiResource)
	 */
	@Override
	public boolean responsibleFor(WikiResource r) {
		return true;
	}

	
	
	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.layout.views.View#getHTMLContent(at.srfg.ikewiki.data.WikiResource)
	 */
	@Override
	public String getHTMLContent(WikiResource context, Perspective perspective1) {
		if(perspective1 instanceof ViewArticlePerspective) {
			try {
				String s = main.getRenderingPipeline().transformReferences(((ViewArticlePerspective)perspective1).getArticle());
				return s.substring(s.indexOf("<div"));
			} catch(RenderingException ex) {
				return "";
			}
		} else {
			return "";
		}
	}
}
