/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.render.elements;

import at.srfg.ikewiki.data.WikiResource;

public class HeadingElement extends WikiElement {
	protected String heading;
	protected int level;	
	public HeadingElement(StringBuilder buffer, WikiResource resource, String heading, int level){
		super(buffer,resource);
		setHeading(heading);
		setLevel(level);
	}
	public final String getHeading() {
		return heading;
	}
	protected final void setHeading(String heading) {
		if(heading == null){
			throw new IllegalArgumentException("null is not allowd for the heading Text");
		}
		this.heading = heading;
	}
	public final int getLevel() {
		return level;
	}
	protected final void setLevel(int level) {
		if(level <1){
			throw new IllegalArgumentException("Level must be number greather equal to one");
		}
		this.level = level;
	}

}
