/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.render.elements;

import at.srfg.ikewiki.data.WikiResource;

public class LinkElement extends WikiElement {
	public static enum LinkTypes{
		internal,wikipedia,external;
	}
	protected String targetName;
	protected LinkTypes linkType;
	public LinkElement(StringBuilder buffer, WikiResource resource, LinkTypes linkType ,String targetName){
		super(buffer,resource);
		setTargetName(targetName);
		setLinkType(linkType);
	}
	public final String getTargetName() {
		return targetName;
	}
	protected final void setTargetName(String targetName) {
		if(targetName == null){
			throw new IllegalArgumentException("The TargetName cannot be null");
		}
		this.targetName = targetName;
	}
	public final LinkTypes getLinkType() {
		return linkType;
	}
	public final void setLinkType(LinkTypes linkType) {
		if(linkType == null){
			throw new IllegalArgumentException("The LinkType cannot be null");
		}
		this.linkType = linkType;
	}

}
