/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.render.elements;

import at.srfg.ikewiki.data.WikiResource;

public abstract class WikiElement {

	protected StringBuilder buffer;
//	protected String type;
	protected WikiResource pageResource;
	
	public WikiElement(StringBuilder buffer, WikiResource pageResource){
		setBuffer(buffer);
//		setType(type);
		setPageResource(pageResource);
	}
	public final StringBuilder getBuffer() {
		return buffer;
	}
	protected final void setBuffer(StringBuilder buffer) {
		if(buffer == null){
			throw new IllegalArgumentException("StringBuffer for writing Widget-Data cannot be null");
		}
		this.buffer = buffer;
	}
	public final WikiResource getPageResource() {
		return pageResource;
	}
	protected final void setPageResource(WikiResource pageResource) {
		if(pageResource == null){
			throw new IllegalArgumentException("WikiResource of the page cannot be null");
		}
		this.pageResource = pageResource;
	}
//	public final String getType() {
//		return type;
//	}
//	protected final void setType(String type) {
//		if(type == null){
//			throw new IllegalArgumentException("The Type of the actual Element cannot be null");
//		}
//		this.type = type;
//	}
}
