<?xml version="1.0" encoding="UTF-8"?>

<!--
    *  Copyright (C) 2005
    *  Sebastian Schaffert and Rupert Westenthaler
    *  Salzburg Research Forschungsgesellschaft m.b.H.
    *
    *  IkeWiki is free software; you can redistribute it and/or
    * 	modify it under the terms of the GNU Lesser General Public
    * 	License as published by the Free Software Foundation; either
    * 	version 2 of the License, or (at your option) any later version.
    *
    * 	This program is distributed in the hope that it will be useful,
    * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
    * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    * 	Lesser General Public License for more details.
    *
    * 	You should have received a copy of the GNU Lesser General Public
    * 	License along with this library; if not, write to the
    * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    * 	Boston, MA 02111-1307, USA.
-->
 
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
     xmlns:fn="http://www.w3.org/2005/xpath-functions"
     xmlns:iw="http://ikewiki.srfg.at/syntax/1.0/ext"
     xpath-default-namespace="http://ikewiki.srfg.at/syntax/1.0/core"
     exclude-result-prefixes="fn iw" 
     version="2.0">
     <xsl:import href="transform-wif-common.xsl"/>
     <xsl:output method="xhtml" encoding="UTF-8" indent="no" omit-xml-declaration="yes"/>
     
     <xsl:template match="/page">
         <div class="search-preview">
             
             <xsl:choose>
                 <xsl:when test="paragraph[1]"><xsl:apply-templates select="paragraph[1]"/></xsl:when>
                 <xsl:otherwise>(no preview available)</xsl:otherwise>
             </xsl:choose>            
             
             
         </div>
     </xsl:template>
     
     <!-- ##################################################################################### -->
     <!-- override definitions for links and headings -->
     
     <!-- internal link -->
     <xsl:template match="intlink">
         
         <xsl:choose>
             <xsl:when test="count(./node()) > 0">
                 <span class="tt-intlink">
                     <xsl:apply-templates/>
                 </span>                
             </xsl:when>
             <xsl:otherwise>
                 <span class="tt-intlink">
                     <xsl:value-of select="@target"/>
                 </span>                                
             </xsl:otherwise>
         </xsl:choose>
         
     </xsl:template>
     
     <!-- external link -->
     <xsl:template match="extlink">
         <xsl:choose>
             <xsl:when test="count(./node()) > 0">
                 <span class="tt-extlink"><xsl:apply-templates/></span>                
             </xsl:when>
             <xsl:otherwise>
                 <span class="tt-extlink"><xsl:value-of select="@href"/></span>                                
             </xsl:otherwise>
         </xsl:choose>
     </xsl:template>
     
      
     <!-- headings are rendered using the HTML h2-h6 elemnents -->
     <xsl:template match="heading">
         
         <xsl:choose>
             <xsl:when test="@level='1'"><h2><xsl:apply-templates/></h2></xsl:when>
             <xsl:when test="@level='2'"><h3><xsl:apply-templates/></h3></xsl:when>
             <xsl:when test="@level='3'"><h4><xsl:apply-templates/></h4></xsl:when>
             <xsl:when test="@level='4'"><h5><xsl:apply-templates/></h5></xsl:when>
             <xsl:when test="@level='5'"><h6><xsl:apply-templates/></h6></xsl:when>
             <xsl:otherwise><h6><xsl:apply-templates/></h6></xsl:otherwise>
         </xsl:choose>
         
     </xsl:template>
     
 </xsl:stylesheet>