<?xml version="1.0" encoding="UTF-8"?>
<!--
    *  Copyright (C) 2006
    *  Sebastian Schaffert and Rupert Westenthaler
    *  Salzburg Research Forschungsgesellschaft m.b.H.
    *
    *  IkeWiki is free software; you can redistribute it and/or
    * 	modify it under the terms of the GNU Lesser General Public
    * 	License as published by the Free Software Foundation; either
    * 	version 2 of the License, or (at your option) any later version.
    *
    * 	This program is distributed in the hope that it will be useful,
    * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
    * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    * 	Lesser General Public License for more details.
    *
    * 	You should have received a copy of the GNU Lesser General Public
    * 	License along with this library; if not, write to the
    * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    * 	Boston, MA 02111-1307, USA.
    * 
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:fn="http://www.w3.org/2005/xpath-functions"
    xmlns:iw="http://ikewiki.srfg.at/syntax/1.0/ext"
    xmlns:rxr="http://ilrt.org/discovery/2004/03/rxr/"
    xpath-default-namespace="http://ikewiki.srfg.at/syntax/1.0/core"
    exclude-result-prefixes="fn iw rxr" 
    version="2.0">
    
    <xsl:template match="/page">
        
        <xsl:apply-templates select="iw:context/rxr:graph"/>
        
    </xsl:template>        

    <xsl:template match="rxr:graph">
        
        <div class="portlet" id="p-references">
            <h5>References</h5>
            
            <div class="pBody"> 
            
                <p class="center">outgoing</p>
                <ul>
                    <!-- <xsl:variable name="untyped_out" select="iw:reference[@iw:typeURI = 'http://ikewiki.srfg.at/IkeWiki#NavigationalLink' and @iw:target and not(some $x in (following-sibling::iw:reference | preceding-sibling::iw:reference) satisfies ($x/@iw:target = @iw:target))]"/> -->
                    <xsl:variable name="untyped_out" select="rxr:triple[@iw:type = 'outgoing' and ./rxr:predicate/@uri = 'http://ikewiki.srfg.at/base/NavigationalLink' and not(some $x in (following-sibling::rxr:triple | preceding-sibling::rxr:triple) satisfies ($x/object = ./object))]"/>
                    <xsl:if test="$untyped_out">
                        <li class="treenode">
                            <a href="">untyped <span class="small">(<xsl:value-of select="count($untyped_out)"/>)</span></a>
                            
                            <ul>
                                <xsl:apply-templates select="$untyped_out"/>
                            </ul>
                        </li>
                        
                    </xsl:if>
                    
                    <!-- <xsl:variable name="other_out" select="iw:reference[not(@iw:typeURI = 'http://ikewiki.srfg.at/IkeWiki#NavigationalLink') and @iw:target]"/> -->
                    <xsl:variable name="other_out" select="rxr:triple[@iw:type = 'outgoing' and not(./rxr:predicate/@uri = 'http://ikewiki.srfg.at/base/NavigationalLink') and rxr:object/@uri]"/>
                    <xsl:for-each-group select="$other_out" group-by="rxr:predicate/@iw:qname">
                        <li class="treenode">
                            <a href="" onmouseover="showWMTT('tt-{rxr:predicate/@iw:qname}')" onmouseout="hideWMTT()"><xsl:value-of select="rxr:predicate/@iw:qname"/> <span class="small">(<xsl:value-of select="count(current-group())"/>)</span></a>

                            <ul>
                                <xsl:apply-templates select="current-group()"/>
                            </ul>
                        </li>                            
                        
                    </xsl:for-each-group>


                </ul>
                
                <p class="center">incoming</p>
                <ul>
                    <!--<xsl:variable name="untyped_in" select="iw:reference[@iw:typeURI = 'http://ikewiki.srfg.at/IkeWiki#NavigationalLink' and @iw:source  and not(some $x in (following-sibling::iw:reference | preceding-sibling::iw:reference) satisfies ($x/@iw:source = @iw:source))]"/> -->
                    <xsl:variable name="untyped_in" select="rxr:triple[@iw:type = 'incoming' and ./rxr:predicate/@uri = 'http://ikewiki.srfg.at/base/NavigationalLink' and not(some $x in (following-sibling::rxr:triple | preceding-sibling::rxr:triple) satisfies ($x/subject = ./subject))]"/>
                    <xsl:if test="$untyped_in">
                        <li class="treenode">
                            <a href="">untyped <span class="small">(<xsl:value-of select="count($untyped_in)"/>)</span></a>
                            
                            <ul>
                                <xsl:apply-templates select="$untyped_in"/>
                            </ul>
                        </li>
                        
                    </xsl:if>
                    
                    <!--<xsl:variable name="other_in" select="iw:reference[not(@iw:typeURI = 'http://ikewiki.srfg.at/IkeWiki#NavigationalLink') and @iw:source]"/>-->
                    <xsl:variable name="other_in" select="rxr:triple[@iw:type = 'incoming' and not(./rxr:predicate/@uri = 'http://ikewiki.srfg.at/base/NavigationalLink') and rxr:subject/@uri]"/>
                    <xsl:for-each-group select="$other_in" group-by="rxr:predicate/@iw:qname">
                        <li class="treenode">
                            <a href="" onmouseover="showWMTT('tt-{rxr:predicate/@iw:qname}')" onmouseout="hideWMTT()"><xsl:value-of select="rxr:predicate/@iw:qname"/> <span class="small">(<xsl:value-of select="count(current-group())"/>)</span></a>
                            
                            <ul>
                                <xsl:apply-templates select="current-group()"/>
                            </ul>
                        </li>                            
                        
                    </xsl:for-each-group>
                    
                    
                </ul>
                
                
            
            </div>
        </div>
    </xsl:template>


    <!-- reference to a literal -->
    <xsl:template match="rxr:triple[rxr:object/text()]">
        <li>
            <div class="references-literal"><xsl:apply-templates select="object"/></div>
        </li>        
    </xsl:template>


    <!-- other outgoing references -->
    <xsl:template match="rxr:triple[@iw:type='outgoing']">
        <li>
            <a href="index.jsp?title={rxr:object/@iw:qname}&amp;action=view" onmouseover="highlightLink('{rxr:object/@iw:qname}'); showWMTT('tt-{rxr:object/@iw:qname}')" onmouseout="unhighlightLink('{rxr:object/@iw:qname}'); hideWMTT()"><xsl:value-of select="rxr:object/@iw:qname"/></a>
        </li>
        
    </xsl:template>

    <!-- other incoming references -->
    <xsl:template match="rxr:triple[@iw:type='incoming']">
        <li>
            <a href="index.jsp?title={rxr:subject/@iw:qname}&amp;action=view" onmouseover="highlightLink('{rxr:subject/@iw:qname}'); showWMTT('tt-{rxr:subject/@iw:qname}')" onmouseout="unhighlightLink('{rxr:subject/@iw:qname}'); hideWMTT()"><xsl:value-of select="rxr:subject/@iw:qname"/></a>
        </li>
        
    </xsl:template>
    

</xsl:stylesheet>