<?xml version="1.0" encoding="UTF-8"?>

<!--
    *  Copyright (C) 2006
    *  Sebastian Schaffert and Rupert Westenthaler
    *  Salzburg Research Forschungsgesellschaft m.b.H.
    *
    *  IkeWiki is free software; you can redistribute it and/or
    * 	modify it under the terms of the GNU Lesser General Public
    * 	License as published by the Free Software Foundation; either
    * 	version 2 of the License, or (at your option) any later version.
    *
    * 	This program is distributed in the hope that it will be useful,
    * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
    * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    * 	Lesser General Public License for more details.
    *
    * 	You should have received a copy of the GNU Lesser General Public
    * 	License along with this library; if not, write to the
    * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    * 	Boston, MA 02111-1307, USA.
    * 
-->

<!-- this stylesheet is used for formatting SPARQL query results as
     HTML -->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
                xmlns:fn="http://www.w3.org/2005/xpath-functions"
                xmlns:sparql="http://www.w3.org/2005/sparql-results#" 
                version="2.0">
    <xsl:output method="xhtml" encoding="UTF-8" indent="no" omit-xml-declaration="yes"/>

    
    
    <xsl:template match="/sparql:sparql">
        <div class="sparql-results">
            <h3>Query Results:</h3>
            
            <table>
                <xsl:apply-templates select="sparql:head"/>
                
                <xsl:apply-templates select="sparql:results"/>
            </table>
            
        </div>
    </xsl:template>
    
    
    <xsl:template match="sparql:head">
        <tr>
            <xsl:for-each select="sparql:variable">
                <th><xsl:value-of select="@name"/></th>
            </xsl:for-each>
        </tr>
    </xsl:template>
    
    
    <xsl:template match="sparql:results">
        <xsl:apply-templates/>        
    </xsl:template>
    
    <xsl:template match="sparql:result">
        <tr>
            <xsl:for-each select="sparql:binding">
                <td>
                    <xsl:apply-templates/>
                </td>                
            </xsl:for-each>
        </tr>
    </xsl:template>
    
    
    <xsl:template match="sparql:unbound">
        <i>-</i>
    </xsl:template>
    
    <xsl:template match="sparql:literal">
        <xsl:apply-templates/>
    </xsl:template>
    
    <xsl:template match="sparql:uri">
        <a href="index.jsp?action=view&amp;uri={fn:replace(./text(),'#','%23')}"><xsl:apply-templates/></a>
    </xsl:template>

    <xsl:template match="sparql:bnode">
        <i><xsl:apply-templates/></i>
    </xsl:template>
    
</xsl:stylesheet>