/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.render.widget.impl;

import java.util.HashSet;
import java.util.Set;

import org.apache.log4j.Logger;

import at.srfg.ikewiki.render.elements.HeadingElement;
import at.srfg.ikewiki.render.widget.AbstractWidget;
import at.srfg.ikewiki.render.widget.Widget;

public class RemoveResourceTypeWidget extends AbstractWidget implements Widget {
	Logger log = Logger.getLogger(RemoveResourceTypeWidget.class); 

	protected static final Set<String> set = new HashSet<String>(1);
	static{
		set.add("heading");
	}
	
	public RemoveResourceTypeWidget(){
		super(set);
	}

	public void doEnd(HeadingElement data) {
		if(data.getLevel()<3){
			data.getBuffer().append("<a  name=\"link-ext-"+data.getPageResource().getQualifiedTitle()+"::"+data.getPageResource().getQualifiedTitle()+"\" href=\"javascript:showExternaliseForm('"+data.getPageResource().getQualifiedTitle()+"','"+data.getPageResource().getQualifiedTitle()+"');\"><img src=\"skins/common/images/button_cancel.png\" /></a>");
		}
	}
	

}
