/**
 *  Copyright (C) 2005
 *  Sebastian Schaffert and Rupert Westenthaler
 *  Salzburg Research Forschungsgesellschaft m.b.H.
 *
 *  IkeWiki is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU Lesser General Public
 * 	License as published by the Free Software Foundation; either
 * 	version 2 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * 	Lesser General Public License for more details.
 *
 * 	You should have received a copy of the GNU Lesser General Public
 * 	License along with this library; if not, write to the
 * 	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * 	Boston, MA 02111-1307, USA.
 * 
 */
package at.srfg.ikewiki.render.wiklet;

import java.util.Collection;
import java.util.HashSet;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.data.Namespace;
import at.srfg.ikewiki.permission.PermissionObject;

public abstract class AbstractWiklet implements Wiklet, PermissionObject {

	protected Main main;
	
	public AbstractWiklet(Main main) {
		super();
		
		this.main = main;
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.permission.PermissionObject#getObjectIdentifier()
	 */
	public String getObjectIdentifier() {
		return Namespace.NS_IKEWIKI_WIKLET+this.getClass().getName();
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.permission.PermissionObject#getRelevantPermissions()
	 */
	public Collection<String> getRelevantPermissions() {
		if(relevantPermissions == null) {
			relevantPermissions = new HashSet<String>();
			relevantPermissions.add("execute");
		}
		return relevantPermissions;
	}
	
	private static Collection<String> relevantPermissions = null;
}
