/**
 * 
 */
package at.srfg.ikewiki.render.wiklet;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import at.srfg.ikewiki.Main;
import at.srfg.ikewiki.data.Namespace;
import at.srfg.ikewiki.data.WikiResource;
import at.srfg.ikewiki.db.DBException;

/**
 * @author sschaffe
 *
 */
public class SparqlWiklet extends AbstractWiklet {

	private static Log log = LogFactory.getLog(SparqlWiklet.class);

	
	
	/**
	 * @param main
	 */
	public SparqlWiklet(Main main) {
		super(main);
	}

	/* (non-Javadoc)
	 * @see at.srfg.ikewiki.render.wiklet.Wiklet#apply(org.w3c.dom.Document, at.srfg.ikewiki.data.WikiResource)
	 */
	public Document apply(Document d, WikiResource context) {
		NodeList nl = d.getElementsByTagNameNS(Namespace.NS_IKEWIKI_EXT,"sparql");
		
		for(int i = 0; i<nl.getLength(); i++) {
			Element e = (Element)nl.item(i);
			String query = e.getTextContent();
			try {
				Document queryResult = main.getStorageBackend().executeSparqlQuery(query);
				e.appendChild(d.importNode(queryResult.getDocumentElement(),true));				

				// add the IkeWiki qualified name to each URI for nicer display as links
				NodeList nl2 = d.getElementsByTagNameNS(Namespace.NS_SPARQL_RESULTS,"uri");
				for(int j = 0; j < nl2.getLength(); j++) {
					Element r = (Element)nl2.item(j);
					WikiResource res = main.getResourceByUri(r.getTextContent().trim());
					r.setAttribute("qName",res.getQualifiedTitle());
					r.setAttribute("lName",res.getTitle());
				}
				
				
				log.info("SPARQL query execution succeeded");
			} catch(DBException ex) {
				log.warn("SPARQL query execution failed.");
			}
		}
		
		return d;
	}

}
