<%--
  *  Copyright (C) 2005
  *  Sebastian Schaffert and Rupert Westenthaler
  *  Salzburg Research Forschungsgesellschaft m.b.H.
  *
  *  IkeWiki is free software; you can redistribute it and/or
  *  modify it under the terms of the GNU Lesser General Public
  *  License as published by the Free Software Foundation; either
  *  version 2 of the License, or (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  *  Lesser General Public License for more details.
  *
  *  You should have received a copy of the GNU Lesser General Public
  *  License along with this library; if not, write to the
  *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  *  Boston, MA 02111-1307, USA.
  * 
--%>
<jsp:directive.page import="at.srfg.ikewiki.Main,at.srfg.ikewiki.render.*,at.srfg.ikewiki.layout.portlet.*,at.srfg.ikewiki.data.*"/>
<jsp:directive.page import="at.srfg.ikewiki.db.*"/>
<jsp:directive.page import="java.util.*"/>

<%!
	Main main;
%>
<%
    try {
	    main = Main.getInstance();
	} catch(DBException ex) {
		response.sendRedirect("setup.jsp");
		return;
	}


    // parse post data, if there is any
	RequestData parameters = main.parseRequestData(request);

	response.setCharacterEncoding("UTF-8");


	String id     = parameters.get("id");
	String action = parameters.get("action");
	String subaction = parameters.get("subaction");
	String title  = parameters.get("title");

	System.err.println("fastform request: action="+action+", subaction="+subaction+", title="+title);
	
	
	
	if(action != null) {
		main.getActionRegistry().handleAction(action,parameters,response,session);
	}
	
	response.setContentType("text/xml");
	
%>
<% if(! (parameters.get("show") != null && parameters.get("show").equals("no")) ) { %>
<div>
	<a href="javascript:closeFFTT('<%=id%>')" class="cancel-button" onmouseover="status='Close'; return true;"><img src="skins/common/images/button_cancel.png"/></a>
<% if(action.equals("edit_references") && subaction != null && subaction.equals("externalise")
		&& parameters.get("object") != null && title != null) {
%>

	<div>
		Please select a type for this link from the list below and press "Add".
	</div>

<%
	String form_id = "form-ext-"+title+"::"+parameters.get("object");

	WikiResource subject = main.getResourceByQTitle(title);
	WikiResource object  = main.getResourceByQTitle(parameters.get("object"));
	Collection<WikiResource> link_types;
	boolean all_types = false;
	if(parameters.get("show_types") != null && parameters.get("show_types").equals("all")) {
		link_types = main.getStorageBackend().getAllProperties();
		all_types = true;
	} else {
		link_types = main.getStorageBackend().getApplicableObjectProperties(subject,object);
	}
%>

	<form id="<%=form_id%>">
		<div>
			<ul>
				<li style="white-space: nowrap"><%=title%> -> <select name="predicate"><% for (WikiResource r : link_types) { %><option><%=r.getQualifiedTitle()%></option><% } %></select>-> <%=parameters.get("object")%>  <input type="button" value="Add" onclick="submitExternaliseForm('<%=form_id%>','<%=title%>','<%=parameters.get("object")%>')"/></li>
			</ul>
		</div>
	</form>

<% } else if(action.equals("edit_types")) { %>

	<div>
		Please select a type for this resource from the list below and press "Add".
	</div>
	
<%
	String form_id = "form-page-type-"+title;

	WikiResource subject = main.getResourceByQTitle(title);

	Collection<WikiResource> has_types = main.getStorageBackend().getDirectTypes(subject);
	Collection<WikiResource> all_types = main.getStorageBackend().getAllTypes();
		
%>	
	
	<form id="<%=form_id%>">
		<div>
			<ul>
				<li style="white-space: nowrap">Type for <%=title %>: <select name="type"><% for (WikiResource r : all_types) { if(!has_types.contains(r)) { %><option><%=r.getQualifiedTitle()%></option><%}  } %></select> <input type="button" value="Add" onclick="submitPageTypeForm('<%=form_id%>','<%=title%>')"/></li>
			</ul>
		</div>
	</form>



<% } else if(action.equals("edit_domain")) { %>

	<div>
		Please select a type to add to the domain from the list below and press "Add".
	</div>

<%
	String form_id = "form-page-domain-"+title;

	WikiResource subject = main.getResourceByQTitle(title);

	Collection<WikiResource> has_domain = main.getStorageBackend().getDomain(subject);
	Collection<WikiResource> all_types = main.getStorageBackend().getAllTypes();		
%>	

	<form id="<%=form_id%>">
		<div>
			<ul>
				<li style="white-space: nowrap">Domain for <%=title %>: <select name="domain"><% for (WikiResource r : all_types) { if(!has_domain.contains(r)) { %><option><%=r.getQualifiedTitle()%></option><%}  } %></select> <input type="button" value="Add" onclick="submitPageDomainForm('<%=form_id%>','<%=title%>')"/></li>
			</ul>
		</div>
	</form>
<% } else if(action.equals("edit_range")) { %>

	<div>
		Please select a type to add to the range from the list below and press "Add".
	</div>

<%
	String form_id = "form-page-range-"+title;

	WikiResource subject = main.getResourceByQTitle(title);

	Collection<WikiResource> has_range = main.getStorageBackend().getRange(subject);
	Collection<WikiResource> all_types = main.getStorageBackend().getAllTypes();		
%>	

	<form id="<%=form_id%>">
		<div>
			<ul>
				<li style="white-space: nowrap">Range for <%=title %>: <select name="range"><% for (WikiResource r : all_types) { if(!has_range.contains(r)) { %><option><%=r.getQualifiedTitle()%></option><%}  } %></select> <input type="button" value="Add" onclick="submitPageRangeForm('<%=form_id%>','<%=title%>')"/></li>
			</ul>
		</div>
	</form>

<% } else if(action.equals("edit_inverse")) { %>

	<div>
		Please select the inverse property from the list below and press "Add".
	</div>

<%
	String form_id = "form-page-inverse-"+title;

	WikiResource subject = main.getResourceByQTitle(title);

	Collection<WikiResource> has_range = main.getStorageBackend().getRange(subject);
	Collection<WikiResource> has_domain = main.getStorageBackend().getDomain(subject);
	Collection<WikiResource> possible_inverse = main.getStorageBackend().getAllProperties(has_range,has_domain);		
%>	

	<form id="<%=form_id%>">
		<div>
			<ul>
				<li style="white-space: nowrap">Range for <%=title %>: <select name="range"><% for (WikiResource r : possible_inverse) { %><option><%=r.getQualifiedTitle()%></option><%  } %></select> <input type="button" value="Add" onclick="submitPageInverseForm('<%=form_id%>','<%=title%>')"/></li>
			</ul>
		</div>
	</form>

<% } else if(action.equals("edit_superclasses")) { %>

	<div>
		Please select a type to add as superclass from the list below and press "Add".
	</div>

<%
	String form_id = "form-page-superclasses-"+title;

	WikiResource subject = main.getResourceByQTitle(title);

	Collection<WikiResource> has_superclasses = main.getStorageBackend().getSuperClasses(subject,false);
	Collection<WikiResource> all_types = main.getStorageBackend().getAllTypes();		
%>	

	<form id="<%=form_id%>">
		<div>
			<ul>
				<li style="white-space: nowrap">Superclass for <%=title %>: <select name="superclass"><% for (WikiResource r : all_types) { if(!has_superclasses.contains(r)) { %><option><%=r.getQualifiedTitle()%></option><%}  } %></select> <input type="button" value="Add" onclick="submitPageSuperClassForm('<%=form_id%>','<%=title%>')"/></li>
			</ul>
		</div>
	</form>

<% } else if(action.equals("edit_superproperties")) { %>

	<div>
		Please select a type to add as superclass from the list below and press "Add".
	</div>

<%
	String form_id = "form-page-superproperties-"+title;

	WikiResource subject = main.getResourceByQTitle(title);

	Collection<WikiResource> has_superproperties = main.getStorageBackend().getSuperProperties(subject,false);
	Collection<WikiResource> all_properties = main.getStorageBackend().getAllProperties();
%>	

	<form id="<%=form_id%>">
		<div>
			<ul>
				<li style="white-space: nowrap">Superproperty for <%=title %>: <select name="superproperty"><% for (WikiResource r : all_properties) { if(!has_superproperties.contains(r)) { %><option><%=r.getQualifiedTitle()%></option><%}  } %></select> <input type="button" value="Add" onclick="submitPageSuperPropertyForm('<%=form_id%>','<%=title%>')"/></li>
			</ul>
		</div>
	</form>


<% } %>
</div>


<% } else { %>
	<div />
<% }%>