<?xml version="1.0" encoding="utf-8"?>

<%--
  *  Copyright (C) 2005
  *  Sebastian Schaffert and Rupert Westenthaler
  *  Salzburg Research Forschungsgesellschaft m.b.H.
  *
  *  IkeWiki is free software; you can redistribute it and/or
  *  modify it under the terms of the GNU Lesser General Public
  *  License as published by the Free Software Foundation; either
  *  version 2 of the License, or (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  *  Lesser General Public License for more details.
  *
  *  You should have received a copy of the GNU Lesser General Public
  *  License along with this library; if not, write to the
  *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  *  Boston, MA 02111-1307, USA.
  * 
--%>

<jsp:directive.page import="at.srfg.ikewiki.Main,at.srfg.ikewiki.render.*,at.srfg.ikewiki.layout.portlet.*,at.srfg.ikewiki.data.*"/>
<jsp:directive.page import="at.srfg.ikewiki.layout.*,at.srfg.ikewiki.layout.perspectives.*,at.srfg.ikewiki.layout.views.*,at.srfg.ikewiki.layout.viewitem.*"/>
<jsp:directive.page import="at.srfg.ikewiki.db.*,at.srfg.ikewiki.editing.templates.*,at.srfg.ikewiki.actions.Action,at.srfg.ikewiki.permission.*"/>
<jsp:directive.page import="java.util.*,java.text.*"/>




<%!
	Main main;
%>


<%--
	main.populateDB();
--%>

<%-- 
	<% Enumeration en = request.getHeaderNames(); 
	   while(en.hasMoreElements()) {	
		   String hdr = (String)en.nextElement();
	%>	   
		<%= hdr %> : <%= request.getHeader(hdr) %> 
	<% } %>
--%>

<%
    try {
	    main = Main.getInstance();
	} catch(DBException ex) {
		response.sendRedirect("setup.jsp");
		return;
	}

		
	boolean is_bot, is_msie;

	// parse post data, if there is any	
	RequestData parameters = main.parseRequestData(request);

	response.setCharacterEncoding("UTF-8");

	String userAgent = request.getHeader("user-agent");
	
	// if user agent is firefox v1.X, output XHTML
	if(userAgent != null && (userAgent.contains("Firefox/1") || userAgent.contains("Gecko")) ) {
		response.setContentType("application/xhtml+xml");
	} else {
		response.setContentType("text/html");		
	}
	
	// Google & MSN bots can destroy the complete knowledgebase if given all options ...
	if(userAgent != null) {
		is_bot  = userAgent.contains("bot");
		is_msie = userAgent.contains("MSIE");
	} else {
		is_bot  = false;		
		is_msie = false;
	}
%>

<%-- quirks to enable IE to render XHTML documents correctly --%>
<% if(is_msie) { %>
<!-- prevent IE from rendering a DOM tree -->
<?xml-stylesheet type="text/xsl" href="xhtml.xsl"?>
<% } %>


<%
	// messages that might be displayed in the page if set
	String message_warning = "", message_error = "";

    // the following parameters are available for every command:
    // - title (a qualified resource title, i.e. of the form ns_prefix:title) is the title of the article to perform the actions on
    // - action (one of "view", "context", "upload_rdf", "edit_references", "edit_content", "edit_metadata", "history", "login", "logout", "namespaces", "search", "upload_image", "variables", "new_resource")
    // - revision (a long value indicating the revision number of the article to retrieve - only applicable to view action)
    // each action may have specific subactions (documented below)
    

	// first get a session object; it is currently used to store information about logged-in users
	User user = (User)session.getAttribute("user");
	
	// check whether a cookie is set, and try to authenticate the user accordingly
	if(user == null) {
		String login = null, password = null;
		if(request.getCookies() != null) {
			for(Cookie c : request.getCookies()) {
				if(c.getName().equals("IkeWikiUser")) {
					login = c.getValue();
				} else if(c.getName().equals("IkeWikiPassword")) {
					password = c.getValue();
				}
			}
		}
		if(login != null && password != null) {
			try {
    			user = main.getPermissionManager().authenticateUser(login,password);
	    		System.err.println("user authenticated via cookie");
		    	session.setAttribute("user",user);
			} catch(Exception ex) {}
		}
	}
	
	SessionHistory history = (SessionHistory)session.getAttribute("history");
	if(history == null) {
		history = new SessionHistory();
		session.setAttribute("history",history);
	}
	
	boolean authenticated = true;
	String error_message = "";
	
	String title_prefix = "", title_postfix="";

	String action = parameters.get("action");
	if(action == null) {
		action = (String)session.getAttribute("last_action");
		
		if(action == null) {
			action = "view";
		}
	}

	if(is_bot) {
		action = "view";
	}

	if(action.equals("view") || action.equals("edit_content") || action.equals("edit_references") || 
	   action.equals("edit_metadata") || action.equals("edit_types") || action.equals("context")) {
		session.setAttribute("last_action",action);
	} else {
		session.removeAttribute("last_action");
	}


	
	
    // read optional title parameter and set article_ns and article_title
    // to the namespace prefix and title of the article; if no title
    // parameter is given, use empty namespace prefix (mapping to "internal")
    // namespace and "FrontPage" title
	String req_title = parameters.get("title");
	
    
	String article_ns, article_title;
	if(req_title == null) {
 		article_ns    = "";
 		article_title = "FrontPage";
 	} else {
 		String[] components = req_title.replace(" ","_").split(":");
 		if(components.length == 2) {
	 		article_ns    = components[0];
	 		article_title = components[1];
	 	} else if(components.length == 1) {
	 		article_ns    = "";
	 		article_title = components[0];
	 	} else {
	 		article_ns    = "";
	 		article_title = "";	 		
	 	}
 	}

		
	// map special pages to actions
	if(main.isSpecial(article_ns,article_title) && main.getSpecialAction(article_title) != null) {
		action = main.getSpecialAction(article_title);
	}
	
	
	
    // create appropriate Renderable object based on the action supplied as
    // parameter.
	Perspective perspective = main.getActionRegistry().handleAction(action,parameters,response,session);
    
    WikiResource context = null;
    
    if(perspective != null) {
		title_prefix = perspective.getTitlePrefix();
		title_postfix = perspective.getTitlePostfix();
		
		context = perspective.getContext(); // may return null	
	} else {
		// TODO: error handling
	}

    if(context == null) {
    	context = main.getDefaultContext();
    }
    
    // TODO: handle this action properly:
	if(action.equals("context")) {
		title_prefix = "Context: ";
	}
	
	if(perspective instanceof ViewArticlePerspective) {
		history.addHistory(((ViewArticlePerspective)perspective).getArticle());
	} else if(perspective instanceof RedirectPerspective) {
		((RedirectPerspective)perspective).performRedirect(response);
		return;
	}
	
    // all locale-specific content is displayed in the locale of the content
	Locale.setDefault(perspective.getLanguage());	
	
	String resource_title = perspective.getQualifiedTitle();	
%>
<!--
Resource URI: <%=perspective.getURI().toString()%>
Action: <%=action%>
Title: <%=req_title%>
-->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:svg="http://www.w3.org/2000/svg" xml:lang="<%= perspective.getLanguage().getLanguage() %>" lang="<%= perspective.getLanguage().getLanguage() %>">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title><%= title_prefix+perspective.getQualifiedTitle()+title_postfix%></title>
    <style type="text/css" media="screen,projection">/*<![CDATA[*/ @import "skins/<%= main.getSkin() %>/main.css"; /*]]>*/</style>
    <link rel="stylesheet" type="text/css" media="screen,projection" href="skins/<%= main.getSkin() %>/addons.css" />
    <link rel="stylesheet" type="text/css" media="print" href="skins/common/commonPrint.css" />
    <link rel="alternate" type="application/rss+xml" title="RSS" href="recent_changes.jsp?format=rss"/>
    <!--[if lt IE 5.5000]><style type="text/css">@import "skins/<%= main.getSkin() %>/IE50Fixes.css";</style><![endif]-->
    <!--[if IE 5.5000]><style type="text/css">@import "skins/<%= main.getSkin() %>/IE55Fixes.css";</style><![endif]-->
    <!--[if gte IE 6]><style type="text/css">@import "skins/<%= main.getSkin() %>/IE60Fixes.css";</style><![endif]-->
    <!--[if IE]><script type="text/javascript" src="skins/common/IEFixes.js"></script>
    <meta http-equiv="imagetoolbar" content="no" /><![endif]-->
    <script type="text/javascript" src="skins/common/wikibits.js"></script>
    <script type="text/javascript" src="skins/common/listmenu.js"></script>
    <script type="text/javascript" src="skins/common/xmlhttprequest.js"></script>
    <script type="text/javascript" src="skins/common/mouseevents.js"></script>
    <script type="text/javascript" src="skins/common/tooltip.js"></script>
    <script type="text/javascript" src="skins/common/fastform.js"></script>
    <script type="text/javascript" src="skins/common/descriptions.js"></script>
<% if(perspective instanceof EditContentPerspective) { %>    
    <script type="text/javascript" src="skins/common/edit_content.js"></script>
<% } %>
<% if(perspective instanceof ViewArticlePerspective) {
	 Hashtable<String,String> dcelements = ((ViewArticlePerspective)perspective).getDublinCore();
	 for(String key : dcelements.keySet()) {
		 if(dcelements.get(key).length() < 100) {
%>    
           <meta name="DC.<%= key %>" content="<%=Main.encodeXML(dcelements.get(key))%>" />
<%
		 }
	 }
   }
%>
<% if(action.equals("edit")) { %>
	<script type="application/x-javascript" src="skins/mozile/ikewiki/wikilink.js"/>
	<script type="application/x-javascript" src="skins/mozile/core/mozile.js"/>
<% } %>	
  </head>
  <body class="ns-0">

	


    <div id="globalWrapper">
  	<% if(is_msie) { %>
  	<div id="msie-warning" class="warning" style="position: absolute; z-index: 15; width: 90%; margin: 5%; font-size: larger; ">
  	<table width="100%">
  		<tr><td><img src="skins/common/images/messagebox_warning_large.png" alt="" /></td><td>
  	<strong>Warning:</strong> You are apparently using Microsoft Internet Explorer. As your browser is not
  	standards compliant, this page will very likely not render correctly. Please download 
  	<a href="http://www.mozilla.org">Mozilla Firefox</a> (version 1.5 preferred) if you want to make full use of this site.
  	<br/>
  	<a href="" onclick="document.getElementById('msie-warning').style.display='none'; return false;">[close]</a>
  	</td>
  	</tr>
  	</table>
  	</div> 
  	<% } %>
      <div id="column-content">

  <% if(action.equals("view") || action.equals("edit_form") || action.equals("edit")) { %>
		<%-- views, should be part of the content div really --%>
		<%--
	    	for(View v : main.getViewsForResource(((ViewArticlePerspective)perspective).getArticle(), View.TYPES.CONTENT_START ) ) { 
	    		out.println(v.getHTMLContent(((ViewArticlePerspective)perspective).getArticle(),perspective));
	    	}
		--%>
    	<%=perspective.getContent() %>

		<%-- views, should be part of the content div really --%>
		<%--
		<%
    		for(View v : main.getViewsForResource(((ViewArticlePerspective)perspective).getArticle(), View.TYPES.CONTENT_END ) ) { 
    			out.println(v.getHTMLContent(((ViewArticlePerspective)perspective).getArticle(),perspective));
    		}
		%>
		--%>
  <% } else { %>

	<div id="content">
	  <a name="top" id="contentTop"></a>
	  <h1 class="firstHeading">
  	  <% if(action.equals("view")) { %>
  	     <a href="#" onmouseover="showWMTT('tt-show-metadata');" onmouseout="hideWMTT();" style="text-decoration: none; color: black;">
  	  <% } %>
	  <%=title_prefix+perspective.getQualifiedTitle()+title_postfix%>
   	  <% if(action.equals("view")) { %>
   	    </a>
  	  <% } %>
	  </h1>
	  
	  
	  <div id="bodyContent">
	    <h3 id="siteSub"><%=main.getTagLine()%></h3>
<!--    <?php if($this->data['undelete']) { ?><div id="contentSub"><?php     $this->html('undelete') ?></div><?php } ?>
	    <?php if($this->data['newtalk'] ) { ?><div class="usermessage"><?php $this->html('newtalk')  ?></div><?php } ?> -->
	    <!-- start content -->
	    <% if(message_warning.length() > 0) { %>
	    <div class="warning">
	    <strong>Warning:</strong>
	    <p><%= message_warning %></p>
	    </div>
	    <% } %>

	   	<%--
	   		if(perspective instanceof ViewArticlePerspective) {
	    		for(View v : main.getViewsForResource(((ViewArticlePerspective)perspective).getArticle(), View.TYPES.CONTENT_START ) ) { 
	    			out.println(v.getHTMLContent(((ViewArticlePerspective)perspective).getArticle(),perspective));
	    		}
	   		}
    	--%>

	    <%-- include appropriate page fragment based on action --%>
		<% if(perspective instanceof ErrorPerspective) { %>  	    	
 			<%@ include file="include/error.jspf" %>
 		<% } else if(action.equals("edit_content")) { %>  	    	
			<%@ include file="include/edit_content.jspf" %>
		<% } else if(action.equals("edit_metadata")) { %>  	    	
			<%@ include file="include/edit_metadata.jspf" %>
		<% } else if(action.equals("edit_types")) { %>  	    	
			<%@ include file="include/edit_types.jspf" %>
		<% } else if(action.equals("edit_references")) { %>  	    	
			<%@ include file="include/edit_references.jspf" %>
		<% } else if(action.equals("history")) { %>  	    	
			<%@ include file="include/history.jspf" %>
		<% } else if(action.equals("context")) { %>
			<img src="ContextImage?title=<%= Main.escapeURL(perspective.getQualifiedTitle()) %>" alt="Context View" />
		<% } else if(action.equals("login")) { %>
			<%@ include file="include/login.jspf" %>
		<% } else if(action.equals("logout")) { %>
			<%@ include file="include/logout.jspf" %>
		<% } else if(action.equals("namespaces")) { %>
			<%@ include file="include/namespaces.jspf" %>
		<% } else if(action.equals("variables")) { %>
			<%@ include file="include/variables.jspf" %>
		<% } else if(action.equals("new_resource")) { %>
			<%@ include file="include/new_resource.jspf" %>
		<% } else if(action.equals("new_class")) { %>
			<%@ include file="include/new_class.jspf" %>
		<% } else if(action.equals("new_property")) { %>
			<%@ include file="include/new_property.jspf" %>
		<% } else if(action.equals("search")) { %>
			<%@ include file="include/search.jspf" %>
		<% } else if(action.equals("recent")) { %>
			<%@ include file="include/recent.jspf" %>
		<% } else if(action.equals("upload_image")) { %>
			<%@ include file="include/upload_image.jspf" %>
		<% } else if(action.equals("upload_rdf")) { %>
			<%@ include file="include/upload_rdf.jspf" %>
		<% } else if(action.equals("related")) { %>
			<%@ include file="include/related.jspf" %>
 		<% } else if(action.equals("edit_users")) { %>  	    	
			<%@ include file="include/edit_users.jspf" %>
 		<% } else if(action.equals("edit_roles")) { %>  	    	
			<%@ include file="include/edit_roles.jspf" %>
		<% } else if(action.equals("search_sparql")) { %>
			<%@ include file="include/sparql.jspf" %>
		<% } %>

	   	<%--
	   		if(perspective instanceof ViewArticlePerspective) {
	    		for(View v : main.getViewsForResource(((ViewArticlePerspective)perspective).getArticle(), View.TYPES.CONTENT_END ) ) { 
	    			out.println(v.getHTMLContent(((ViewArticlePerspective)perspective).getArticle(),perspective));
	    		}
	   		}
    	--%>
	    <!-- end content -->
	    <div class="visualClear"></div>
	  </div>
	</div>
	
	<% } // not action view %>

      </div>
      <div id="column-one">
    <% if(!is_bot) { %>
	<div id="p-cactions" class="portlet">
	  <h5>Views</h5>
	  <ul>
	    <%-- list all actions defined in Main --%>
	  	<% for(Action v : main.getContextActions(perspective,user,context)) { %>
	  		<li id="ca-<%=v.getIdentifier()%>" <% if(v.getIdentifier().equals(action)) {%>class="selected"<%}%> >
	  			<a href="<%=request.getRequestURI()%>?title=<%=Main.encodeURL(perspective.getQualifiedTitle())%>&amp;action=<%=v.getIdentifier()%>"><%=v.getLabel()%></a>
	  		</li>
	  	<%	} %>
	  </ul>
	</div>
	<div class="portlet" id="p-personal">
	  <h5>Personal tools</h5>
	  <div class="pBody">
	    <ul>
	      <% if(user != null) { %>
	    	<li id="pt-userpage"><a href="index.jsp?title=user:<%= user.getLogin() %>"><%= user.getLogin() %></a>, <a href="index.jsp?title=<%=perspective.getQualifiedTitle()%>&amp;action=logout">log out</a></li>
	      <% } else { %>
	    	<li id="pt-login"><a href="index.jsp?action=login">create account / log in</a></li>
	      <% } %>
	    </ul>
	  </div>
	</div>
	<div class="portlet" id="p-logo">
	  <a style="background-image: url(<%=main.getLogoPath()%>);"
	    href="index.jsp?title=FrontPage"
	    title="Main Page"></a>
	</div>
	<script type="text/javascript"> if (window.isMSIE55) fixalpha(); </script>
	<%-- create all portlets --%>
	<%
		HashMap<String,String> portlet_variables = new HashMap<String,String>();
		portlet_variables.put("title",perspective.getQualifiedTitle());
	%>
	<% for(Portlet p : main.getPortlets()) { %>
	<div class='portlet' id='<%= p.getKey() %>'>
	  <h5><%= p.getTitle() %></h5>
	  <div class='pBody'>
	    <ul>
	    <% for(PortletItem pi : p.portletItems(user,context)) { %>
	      <li id="<%= pi.getKey() %>"><a href="<%= pi.getActionString(portlet_variables) %>"><%= pi.getTitle() %></a></li>
	     <% } %>
	    </ul>
	  </div>
	</div>
	<% } %>
	<div id="p-search" class="portlet">
	  <h5><label for="searchInput">Search</label></h5>
	  <div class="pBody">
	    <form name="searchform" action="index.jsp?action=search" id="searchform" method="post" enctype="multipart/form-data">
	      <input id="searchInput" name="search" type="text" accesskey="f" />
	      <input type='submit' name="go" class="searchButton" id="searchGoButton"
	        value="Go"
	        /> <input type='submit' name="fulltext"
	        class="searchButton"
	        value="Search" />
	    </form>
	  </div>
	</div>
	<% } %>
<%--	<div class="portlet" id="p-tb">
	  <h5>Toolbox</h5>
	  <div class="pBody">
	    <ul>
		  <li id="t-whatlinkshere"><a href="index.jsp?title=<%=perspective.getQualifiedTitle()%>&action=whatlinkshere">What links here</a></li>
		  <li id="t-recentchanges"><a href="index.jsp?title=<%=perspective.getQualifiedTitle()%>&action=recentchanges">Related changes</a></li>
	    </ul>
	  </div>
	</div> --%>

	<% if(history.size() > 1) { %>
	<div class="portlet" id="p-history">
	  <h5>History</h5>
	  <div class="pBody">
		<ul>
			<% for(WikiResource r : history) { %>
			  <li><a href="index.jsp?title=<%= Main.encodeURL(r.getQualifiedTitle()) %>&amp;action=<%=action %>"><%= r.getQualifiedTitle()%></a></li>
			<% } %>
		</ul>
      </div>
    </div>
    <% } %>
	<%-- show context-sensitve portlets on the left-hand side --%>
   	<%
	if(perspective instanceof ViewArticlePerspective) {
   		for(View v : main.getViewsForResource(((ViewArticlePerspective)perspective).getArticle(), View.TYPES.PORTLET_LEFT ) ) { 
   			out.println(v.getHTMLContent(((ViewArticlePerspective)perspective).getArticle(),perspective));
   		}
	}
   	%>

	<%-- show context-sensitve portlets on the right-hand side --%>
	<div id="p-bar-right">
	   	<%
   		if(perspective instanceof ViewArticlePerspective) {
    		for(View v : main.getViewsForResource(((ViewArticlePerspective)perspective).getArticle(), View.TYPES.PORTLET_RIGHT ) ) { 
    			out.println(v.getHTMLContent(((ViewArticlePerspective)perspective).getArticle(),perspective));
    		}
   		}
    	%>
    </div>


      </div><!-- end of the left (by default at least) column -->
      <div class="visualClear"></div>
      <div id="footer">
      	<div id="f-feeds">
      		<a href="recent_changes.jsp?format=rss"><img src="skins/common/images/rssbutton.png" border="0" alt="RSS feed"/></a>      		
      	</div>
    	<div id="f-poweredbyico">
    	<a href="http://www.w3.org/RDF/" title="RDF Resource Description Framework"> <img border="0" src="skins/common/images/rdf_metadata_button.32.gif"
alt="RDF Resource Description Framework Metadata Icon" /></a></div>
	<ul id="f-list">
	  <li id="f-lastmod">This page was last modified <%=perspective.getLastModified().toLocaleString() %>
	  <% if(perspective instanceof ViewArticlePerspective) { %>
	   by <% if( ((ViewArticlePerspective)perspective).getArticle().getCreator() != null) { %><a href="index.jsp?title=User:<%= ((ViewArticlePerspective)perspective).getArticle().getCreator() %>"><%= ((ViewArticlePerspective)perspective).getArticle().getCreator() %></a><% } else { %>Anonymous<% } %>.
	  <% } %>
	  </li>
	  <!-- <li id="f-viewcount">Viewcount: <%=perspective.getViewCount()%></li> -->
	</ul>
      </div>
    </div>
    IkeWiki version <%=main.getVersion()%> - <%=Calendar.getInstance().getTime()%>
    
    
    
	<%-- Tooltips are "cached" in this div --%>
	<div id="tooltips">	    
		<% if(action.equals("edit_content")) { %>
	<div id="typelist" class="fastform">
		<div>
			<a href="javascript:hideTypeList()" class="cancel-button" onmouseover="status='Close'; return true;"><img src="skins/common/images/button_cancel.png"/></a>
<%
	WikiResource subject = main.getResourceByQTitle(perspective.getQualifiedTitle());

	Collection<WikiResource> all_types = main.getStorageBackend().getAllTypes();
		
%>	
			<div>Select a type from the list below and press "Add".</div>
	
			<form id="form-typelist">
				<div>
					<ul>
						<li style="white-space: nowrap">Add Type: <select name="type"><% for (WikiResource r : all_types) { %><option><%=r.getQualifiedTitle()%></option><%  } %></select> <input type="button" value="Add" onclick="submitTypeListForm()"/></li>
					</ul>
				</div>
			</form>
		</div>
	</div>
		<% } %>	
<%--		
		<% if(action.equals("view")) { %>
			<% ViewItem avi = main.getViewItemFactory().getViewItem(main.getResourceByQTitle(perspective.getQualifiedTitle())); %>
			 <div  id="tt-show-metadata" class="tooltip">
				<br />
			  	<div class="pBody">
				<h5>Metadata for <%= avi.getLabel()%>:</h5>
				<hr />
				<table>
				  <% for(Iterator<String> keys = avi.getLiteralKeys(); keys.hasNext();){ %>
				  	<% ViewItem kvi = main.getViewItemFactory().getViewItem(main.getResourceByQTitle(keys.next())); %>
					<tr>
					  <td><%= kvi.getLabel() %></td>
					  <td>-&gt;</td>
					  <td>
						<% for(Iterator<String> actLiterals = avi.getLiteral(kvi.getID());actLiterals.hasNext();){ %>
							<%= actLiterals.next()%><br />
						<% } %>
					  </td>
					</tr>
				  <% } %>
				</table>
				</div>
			</div>
		<% } %>					
--%>
	</div>

  </body>
</html>

