<%--
  *  Copyright (C) 2005
  *  Sebastian Schaffert and Rupert Westenthaler
  *  Salzburg Research Forschungsgesellschaft m.b.H.
  *
  *  IkeWiki is free software; you can redistribute it and/or
  *  modify it under the terms of the GNU Lesser General Public
  *  License as published by the Free Software Foundation; either
  *  version 2 of the License, or (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  *  Lesser General Public License for more details.
  *
  *  You should have received a copy of the GNU Lesser General Public
  *  License along with this library; if not, write to the
  *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  *  Boston, MA 02111-1307, USA.
  * 
--%>
<%--
<?xml version="1.0" encoding="utf-8"?>

<!DOCTYPE div PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
--%>

<jsp:directive.page import="at.srfg.ikewiki.Main,at.srfg.ikewiki.render.*,at.srfg.ikewiki.layout.perspectives.*,at.srfg.ikewiki.layout.views.*,at.srfg.ikewiki.layout.portlet.*,at.srfg.ikewiki.data.*"/>
<jsp:directive.page import="at.srfg.ikewiki.db.*"/>
<jsp:directive.page import="java.util.*,java.text.*"/>


<%!
	Main main;
%>
<%
    try {
	    main = Main.getInstance();
	} catch(DBException ex) {
		response.sendRedirect("setup.jsp");
		return;
	}
	// parse post data, if there is any
	RequestData parameters = main.parseRequestData(request);
	
	
 
	// first get a session object; it is currently used to store information about logged-in users
	User user = (User)session.getAttribute("user");
	
	// check whether a cookie is set, and try to authenticate the user accordingly
	if(user == null) {
		String login = null, password = null;
		if(request.getCookies() != null) {
			for(Cookie c : request.getCookies()) {
				if(c.getName().equals("IkeWikiUser")) {
					login = c.getValue();
				} else if(c.getName().equals("IkeWikiPassword")) {
					password = c.getValue();
				}
			}
		}
		if(login != null && password != null) {
			try {
    			user = main.getPermissionManager().authenticateUser(login,password);
	    		System.err.println("user authenticated via cookie");
		    	session.setAttribute("user",user);
			} catch(Exception ex) {}
		}
	}
	
	
	RecentChangesPerspective perspective=main.getRecentChangesPerspective();

	response.setContentType("text/xml");

	DateFormat df = new SimpleDateFormat("EEE, dd MMM yyyy HH:mm:ss Z",Locale.ENGLISH);

	System.err.println("requested RSS feed for recent changes");
%>
<rss version="2.0">
	<channel>
		<title>IkeWiki at <%= main.getBaseUri() %></title>
		<link><%= main.getBaseUri() %></link>
		<description>Recent Changes from IkeWiki</description>
		<generator>IkeWiki <%= main.getVersion() %></generator>
		<pubDate><%= df.format(new Date()) %></pubDate>
		<ttl>60</ttl>
		
		<% for(Article a : perspective.getRecentChanges(20,0)) { %>
			<%= main.getRenderingPipeline().transformRecentChangesResultRSS(a) %>
		<% } %>
	</channel>
</rss>
<% 


%>