<%--
  *  Copyright (C) 2005
  *  Sebastian Schaffert and Rupert Westenthaler
  *  Salzburg Research Forschungsgesellschaft m.b.H.
  *
  *  IkeWiki is free software; you can redistribute it and/or
  *  modify it under the terms of the GNU Lesser General Public
  *  License as published by the Free Software Foundation; either
  *  version 2 of the License, or (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  *  Lesser General Public License for more details.
  *
  *  You should have received a copy of the GNU Lesser General Public
  *  License along with this library; if not, write to the
  *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  *  Boston, MA 02111-1307, USA.
  * 
--%>
<jsp:directive.page import="at.srfg.ikewiki.installer.*,java.sql.*,java.io.*,at.srfg.ikewiki.data.*"/>

<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
    pageEncoding="ISO-8859-1"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<title>Setup IkeWiki</title>
</head>
<body>

<div class="content" style=" background-color: #ffffe6; margin-left: 5%; margin-right: 5%; border: 1px solid black; padding: 1em;">

<%
if(request.getParameter("submit") != null) {
	
	if(request.getParameter("hostname") != null && request.getParameter("port") != null &&
		request.getParameter("root-name") != null && request.getParameter("root-pass") != null &&
		request.getParameter("db-name") != null && request.getParameter("db-pass") != null &&
		request.getParameter("db-user") != null) {
	
		InitDB initdb = new InitDB(request.getParameter("hostname"),request.getParameter("port"), request.getParameter("db-name"),
								   request.getParameter("root-name"),request.getParameter("root-pass"),
								   request.getParameter("db-user"),request.getParameter("db-pass")
								   );
		
		
		
		try {
			initdb.initConfig(this.getServletContext());
			initdb.initDatabase();
%>
<h1>Setup IkeWiki (2 - Preload Ontologies)</h1>

<p>
The database has now been initialised successfully. You may now either go directly to <a href="index.jsp">index.jsp</a> and start working with an empty Wiki, 
or preload some common existing ontologies that offer commonly found properties and types for your links and pages. Please tick below all ontologies you want to 
preload. <span style="color: red; font-weight: bold">Note that this operation can take several minutes, depending on the size of the ontologies you chose</span>.
</p>

<form action="setup.jsp" method="post">
  <input type="hidden" name="step" value="load_ontologies"/>

<style type="text/css">
  td {
    vertical-align: top;
  }
</style>
  <table style="margin: 1em">
	<tr>
		<td><input type="checkbox" name="ontology" value="rdf-schema" checked="checked"/></td>
		<td><strong>RDF Schema</strong></td>
		<td>RDF Schema defines basic concepts like "class", "resource", and "property", and basic properties like "type", "subclass", and "comment". 
		    <br /><em>Loading this ontology is required.</em>
		</td>
	</tr>
	<tr>
		<td><input type="checkbox" name="ontology" value="owl" checked="checked"/></td>
		<td><strong>OWL</strong></td>
		<td>The "Ontology Web Language" allows you to define more complex ontologies. <br /><em>Loading this ontology is required.</em>
		</td>
	</tr>
	<tr>
		<td><input type="checkbox" name="ontology" value="dc" checked="checked"/></td>
		<td><strong>Dublin Core</strong></td>
		<td>Dublin Core defines concepts that allow to describe meta-properties of textual content, like "creator", "publisher", "rights", etc. <br /><em>Loading this ontology is required.</em>
		</td>
	</tr>
	<tr>
		<td><input type="checkbox" name="ontology" value="ikewiki" checked="checked"/></td>
		<td><strong>IkeWiki Base System</strong></td>
		<td>The IkwWiki Base System contains types that are used internally in IkeWiki for data representation purposes (e.g. images)<br /><em>Loading this ontology is recommended.</em>
		</td>
	</tr>
	<tr>
		<td><input type="checkbox" name="ontology" value="help" checked="checked"/></td>
		<td><strong>IkeWiki Help System</strong></td>
		<td>The IkeWiki Help System provides the documentation and help pages for IkeWiki. 
		    <br /><em>Loading this ontology is recommended. If you load this ontology, you should also load OWL and Dublin Core above.</em>
		</td>
	</tr>

	<tr>
		<td><input type="checkbox" name="ontology" value="cc" checked="checked"/></td>
		<td><strong>Creative Commons</strong></td>
		<td>Allows to attach creative commons licensing information to resources.
		<br /><em>Loading this ontology is recommended.</em>
		</td>
	</tr>

	<tr>
		<td><input type="checkbox" name="ontology" value="foaf" checked="checked"/></td>
		<td><strong>Friend of a Friend</strong></td>
		<td>Loads the "friend-of-a-friend" (FOAF) ontology. IkeWiki makes use of it for storing user-specific data.
		<br /><em>Loading this ontology is recommended.</em>
		</td>
	</tr>


	<tr>
		<td><input type="checkbox" name="ontology" value="sumo"/></td>
		<td><strong>SUMO</strong></td>
		<td>Sumo is a foundational ontology that describes fundamental concepts like "Entity", "Attribute", etc. <br /><em>Loading this ontology is optional.</em>
		</td>
	</tr>
	<tr>
		<td><input type="checkbox" name="ontology" value="dolce-lite"/></td>
		<td><strong>DOLCE Lite</strong></td>
		<td>DOLCE is a foundational ontology that describes fundamental concepts like "Entity", "Attribute", etc. <br /><em>Loading this ontology is optional.</em>
		</td>
	</tr>
	<tr>
		<td><input type="checkbox" name="ontology" value="skos"/></td>
		<td><strong>SKOS</strong></td>
		<td>Simple Knowledge Organisation System. SKOS provides a model for expressing the basic structure and content of concept schemes (thesauri, classification schemes, subject heading lists, taxonomies, terminologies, glossaries and other types of controlled vocabulary). <br /><em>Loading this ontology is optional.</em>
		</td>
	</tr>
	<tr>
		<td><input type="checkbox" name="ontology" value="lom"/></td>
		<td><strong>LOM</strong></td>
		<td>Learning Objects Metadata. This standard will specify the syntax and semantics of Learning Object Metadata, defined as the attributes required to fully/adequately describe a Learning Object. Learning Objects are defined here as any entity, digital or non-digital, which can be used, re-used or referenced during technology supported learning.
		<br /><em>Loading this ontology is optional.</em>
		</td>
	</tr>
	<tr>
		<td><input type="checkbox" name="ontology" value="biology"/></td>
		<td><strong>Biology</strong></td>
		<td>Provides the basic relationships and types of biological taxonomy. This ontology is provided as an example.
		<br /><em>Loading this ontology is optional.</em>
		</td>
	</tr>
	<tr>
		<td><input type="checkbox" name="ontology" value="bibtex"/></td>
		<td><strong>Bibtex</strong></td>
		<td>Allows to describe citations and annotate links as references to citations. This ontology is provided as an example.
		<br /><em>Loading this ontology is optional.</em>
		</td>
	</tr>
	<tr>
		<td><input type="checkbox" name="ontology" value="exif"/></td>
		<td><strong>EXIF</strong></td>
		<td>Allows to extract and store image metadata from uploaded images.
		<br /><em>Loading this ontology is optional.</em>
		</td>
	</tr>


  </table>
  
<input type="submit" name="submit" value="Load Ontologies"/>

</form>
<%		
		} catch(SQLException ex) {
			StringWriter w = new StringWriter();
			ex.printStackTrace(new PrintWriter(w));
			String trace = w.toString();
%>			
<div class="error">
  <strong>Error:</strong> <%= ex.getLocalizedMessage() %><br />
  <% if(ex.getNextException() != null) { %>
  <strong>Cause:</strong> <%= ex.getNextException().getLocalizedMessage() %><br />
  <% } %>
  <em>Details:</em> <br />
  <pre><%= trace %></pre>
</div>
<%			
		} finally {
			initdb.close();
		}
	} else if(request.getParameter("step") != null && request.getParameter("step").equals("load_ontologies")) {
		
		
		try {
			InitOntologies inito = new InitOntologies(request.getParameterValues("ontology"));
			inito.initOntologies();

%>
<h1>Setup IkeWiki (3 - Select Permission Profile)</h1>

<p>
	IkeWiki comes with a very flexible permission system that allows to selectively associate actions with
	resources for a user. To make the initial setup simple, the setup script provides a selection of standard
	permission sets for commonly found scenarios.
</p>

<form action="setup.jsp" method="post">
  <input type="hidden" name="step" value="load_data"/>

  <h2>Permission Set</h2>

  <table>
  	<tr>
  		<td>
  			<input type="radio" name="permission_set" value="simple"/>
  		</td>
  		<td>
  			Give all users full permissions except role and user management; this is the least restrictive 
  			permission set as commonly found in other Wiki systems.
  		</td>
	</tr>
	<tr>
  		<td>
  			<input type="radio" name="permission_set" value="authenticated"/>
  		</td>
  		<td>
  			Give authenticated users full permissions except role and user management, anonymous users only 
  			view permission; this is ensures that no anonymous modifications can be done.
  		</td>
  	</tr>
	<tr>
  		<td>
  			<input type="radio" name="permission_set" value="restricted" checked="checked" />
  		</td>
  		<td>
  			Give authenticated users full editing permissions on the base namespace and only view permissions
  			on all other namespaces. This is currently the most restrictive permission set.
  		</td>
  	</tr>
  </table>

  <h2>Administrator Password</h2>

  <p>
     Please choose an initial password for the 'Administrator' account. The 'Administrator' is a default user
     with full access to all capabilities of the system, regardless of the chosen permission set.
  </p>

  <table>
  	<tr>
  		<td>Password:</td><td><input type="password" name="password1" /></td>
  	</tr>
  	<tr>
  		<td>Repeat:</td><td><input type="password" name="password2" /></td>
  	</tr>
  </table>	


  <input type="submit" name="submit" value="Submit" />
</form>
<p>
<strong>Info:</strong> <%=  inito.getRDFStore().getModel().size() %> triples have been preloaded in IkeWiki.
</p>
<%
			
		} catch(Exception ex) {
			StringWriter w = new StringWriter();
			ex.printStackTrace(new PrintWriter(w));
			String trace = w.toString();
			%>			
			<div class="error">
			  <strong>Error:</strong> <%= ex.getLocalizedMessage() %><br/>
			  <em>Details:</em> <%= trace %>
			</div>
			<%					
		}
	} else if(request.getParameter("step") != null && request.getParameter("step").equals("load_data")) {
		try {
			String password1 = request.getParameter("password1");
			String password2 = request.getParameter("password2");
			
			if(!password1.equals(password2)) {
				throw new WikiException("The passwords for the Administrator account don't match!");
			}
			
			InitData initd = new InitData();
			initd.initData(password1,request.getParameter("permission_set"));
%>
<h1>Setup IkeWiki (4 - Finish)</h1>

<p>
Congratulations! Your Wiki is now ready for use. You may now want to go to <a href="index.jsp">index.jsp</a> and start working with your Wiki.
</p>

<%
			
		} catch(Exception ex) {
			StringWriter w = new StringWriter();
			ex.printStackTrace(new PrintWriter(w));
			String trace = w.toString();
			%>			
			<div class="error">
			  <strong>Error:</strong> <%= ex.getLocalizedMessage() %><br/>
			  <em>Details:</em> <%= trace %>
			</div>
			<%					
		}
	} else {
%>
<div class="error">
  <strong>Error:</strong> You need to fill in all values
</div>
<%		
	}
	
%>	

<%	
} else {
%>

<h1>Setup IkeWiki (1 - Initialise Database)</h1>

<p>
Welcome to IkeWiki! This installer will help you to set up your database for use with IkeWiki. Please proceed to each of the steps and follow the given instructions carefully.
</p>

<h3>1. Setup and Start Postgres Database</h3>

<p>
  IkeWiki currently uses PostgreSQL version 7.4 or higher as database. 
</p>

<ol>  
 <li>download a package appropriate for your platform from <a href="http://www.postgresql.org">postgresql.org</a> , install it, and start postgres</li>
 <li>setup a user (referred to in the following as "superuser") that is allowed to create new databases and users; you can do this on the commandline as follows (for a user "root"):
   <pre>
   createuser -a -d -P root
   </pre>
   under Unix, you first need to <tt>su</tt> to the <tt>postgres</tt> user.
 </li>
 <li>setup database to accept TCP/IP connections; find the configurarion file <tt>postgresql.conf</tt> and set the option <tt>tcpip_socket</tt> to <tt>true</tt>.</li>
 <li>setup database to accept password-based authentication; find the configuration file <tt>pg_hba.conf</tt> and add the following line <b>to the top of the file</b>:
 <pre>
 host    all         all         127.0.0.1         255.255.255.255   md5
 </pre>
 instead of 127.0.0.1/255.255.255.255 you might want to use a different IP address and netmask to allow connections from different hosts.
 </li>
 <li>restart database</li>
</ol>

<hr />
<h3>2. Setup of IkeWiki Tables</h3>

<p>
In the following form, enter the hostname, port, superuser name and superuser password as configured above. If you are finished, click on "Create Tables".
This will create a new database named "ontowiki" and all required tables for the system to work.
</p>

<form action="setup.jsp" method="post">
  <input type="hidden" name="step" value="init_database"/>
	<table>
		<tr>
			<td><b>Hostname:</b></td>
			<td><input type="text" size="20" name="hostname" value="localhost"/></td>			
		</tr>
		<tr>
			<td><b>Port:</b></td>
			<td><input type="text" size="20" name="port" value="5432"/></td>			
		</tr>
		<tr>
			<td><b>Superuser Name:</b></td>
			<td><input type="text" size="20" name="root-name" value=""/></td>			
		</tr>
		<tr>
			<td><b>Superuser Password:</b></td>
			<td><input type="password" size="20" name="root-pass" value=""/></td>			
		</tr>
		
		<tr>
			<td><b>IkeWiki Database:</b></td>
			<td><input type="text" size="20" name="db-name" value="ikewiki"/></td>			
		</tr>
		<tr>
			<td><b>IkeWiki User Name:</b></td>
			<td><input type="text" size="20" name="db-user" value="ikewiki"/></td>			
		</tr>
		<tr>
			<td><b>IkeWiki User Password:</b></td>
			<td><input type="password" size="20" name="db-pass" value="ikewiki"/></td>			
		
		<tr>
		  <td colspan="2"><input type="submit" name="submit" value="Create Tables"/></td>
		</tr>
	</table>
</form>

<% } %>

</div>
</body>
</html>