/**
 * Places to check when modifying:
 * - index.jsp, action handler for edit_content
 * - index.jsp, tooltips div (defines typelist form)
 * - edit_content.jspf
 */


function addType(type) {
    var type_elem = document.getElementById('wpTypes');
    
    // check whether type already exists
    var node = type_elem.firstChild;
    while(node != null) {
        if(node.nodeType == 1 && node.getAttribute('name') == type) {
            return;
        }
        if(node == type_elem.lastChild) {
            break;
        } else {
            node = node.nextSibling;
        }
    }
    
    // add a hidden input field and some text
    var span = document.createElement("span");
    span.setAttribute("name",type);
    if(type_elem.childNodes.length > 0) {
        type_elem.insertBefore(span,type_elem.firstChild);
    } else {
        type_elem.appendChild(span);
    }    
    
    
    var inp = document.createElement("input");
    inp.setAttribute("type","hidden");
    inp.setAttribute("name","add-type");
    inp.setAttribute("value",type);
    span.appendChild(inp);
    
    var txt = document.createElement("a");
    txt.setAttribute("href","javascript:removeType('"+type+"');");
    txt.setAttribute("class","direct-type");
    span.appendChild(txt);
    
    if(type_elem.childNodes.length > 0) {            
        txt.appendChild(document.createTextNode(type+', '));
    } else {
        txt.appendChild(document.createTextNode(type));
    }    
}

function removeType(type) {
    var type_elem = document.getElementById('wpTypes');
    
    // check whether type already exists
    var node = type_elem.firstChild;
    while(node != null) {
        if(node.nodeType == 1 && node.getAttribute('name') == type) {
            type_elem.removeChild(node);
            return;
        } else if(node.nodeType == 1 && node.getAttribute('name') == 'old-'+type) {
            var inp = document.createElement("input");
            inp.setAttribute("type","hidden");
            inp.setAttribute("name","remove-type");
            inp.setAttribute("value",type);
        
            type_elem.replaceChild(inp,node);
            return;
        }
        if(node == type_elem.lastChild) {
            break;
        } else {
            node = node.nextSibling;
        }
    }
    
}


var fftl = null;

/**
 * show the type list div, which is defined in index.jsp for the edit_content action
 */
function showTypeList() {
	fftl = document.getElementById("typelist");
	if(fftl == null) {
	    alert("element not found!");
	}


	fftl.style.display = "block"

	x = getMouseX();
	y = getMouseY();
	if (fftl != null) {
		if(x < window.innerWidth - fftl.offsetWidth - 20) {
			fftl.style.left = (x + 20) + "px";
		} else {
			fftl.style.left =  (window.innerWidth - fftl.offsetWidth - 20) + "px";
		}
		fftl.style.top 	= (y + 20) + "px";
	}

}

function hideTypeList() {
	fftl.style.display = "none";
}


function submitTypeListForm() {
	var form_id = "form-typelist";

	hideTypeList();	

	var form = document.forms[form_id];

	if(form != null) {
		var type = form.type.value;

        addType(type);
		
	} else {
		alert("could not store type!");
	}

}
