// JavaScript support for "fast forms" that occur in a tooltip-like manner and do not require
// changing from the article view to a different view
//
//

var fftt = null;

var ffurl = "fastform.jsp?action=";


function showFFTT(id,url) {
	fftt = document.getElementById(id);
	if(fftt == null) {
		fftt = requestFFTooltip(id,url);
		fftt.style.left = "0";
		fftt.style.top = "0";
	}



	fftt.style.display = "block"

	x = getMouseX();
	y = getMouseY();
	if (fftt != null) {
		if(x < window.innerWidth - fftt.offsetWidth - 20) {
			fftt.style.left = (x + 20) + "px";
		} else {
			fftt.style.left =  (window.innerWidth - fftt.offsetWidth - 20) + "px";
		}
		fftt.style.top 	= (y + 20) + "px";
	}

	//timerId = setTimeout('showFFTT("'+id+'","'+url+'"); clearTimeout(timerId); ',500);
}

function hideFFTT() {
	fftt.style.display = "none";
}


function requestFFTooltip(id,url) {
	// tooltip ids always begin with tt- followed by the qualified title
	
	// extract qualified title
	var title = id.substring(3,id.length);
	
	var tooltips = document.getElementById('tooltips');
	
	
	var elem = document.createElement("div")	;
	elem.setAttribute("id",id);
	elem.setAttribute("class","fastform");
	elem.innerHTML = " ";
	tooltips.appendChild(elem);

	var http = getHTTPObject(); // We create the HTTP Object 

	http.open("GET", url , true);
	http.onreadystatechange = function() {
		if(http.readyState == 4) {
			elem.innerHTML = http.responseText;
		}
	}	
	http.send("");
	
	return elem;
}

function closeFFTT(id) {
	fftt = document.getElementById(id);
	if(fftt != null) {
		fftt.style.display="none";
	}
}



function showExternaliseForm(subject,object) {
	var id = "ef-"+subject+"::"+object;
		
//	var url = ffurl + "edit_references&subaction=externalise&show_types=all&id="+id+"&title="+escape(subject)+"&object="+escape(object);
//	var url = ffurl + "edit_references&subaction=externalise&id="+id+"&title="+escape(subject)+"&object="+escape(object);
	var url = ffurl + "edit_references&subaction=externalise&id="+id+"&title="+subject+"&object="+object;
	
	showFFTT(id,url);
	
	// show it again, to ensure a correct positioning
	timerId = setTimeout('showFFTT("'+id+'","'+url+'"); clearTimeout(timerId); ',500);
	
}




function submitExternaliseForm(id,subject,object) {
	var id = "ef-"+subject+"::"+object;
	var form_id = "form-ext-"+subject+"::"+object;

	closeFFTT(id);	

	var form = document.forms[form_id];

	if(form != null) {
		var predicate = form.predicate.value;
		

		var http = getHTTPObject(); // We create the HTTP Object 
		var url = ffurl + "edit_references&subaction=store&show=no&id="+id+"&title="+subject+"&subject="+subject+"&predicate="+predicate+"&object="+object;

		http.open("GET", url , true);
		http.onreadystatechange = function() {
			if(http.readyState == 4) {
			    updateContent(subject);
				updateReferences(subject);
				var links = document.getElementsByName("link-ext-"+subject+"::"+object);
				for(var i = 0; i<links.length; i++) {
					links[i].style.display="none";
				}
			}
		}	
		http.send("");
		
	} else {
		alert("could not store external link!");
	}

}


function showPageTypeForm(subject) {
	var id = "pt-"+subject;
		
	var url = ffurl + "edit_types&id="+id+"&title="+subject;
	
	showFFTT(id,url);
	
	// show it again, to ensure a correct positioning
	timerId = setTimeout('showFFTT("'+id+'","'+url+'"); clearTimeout(timerId); ',500);
	
}

function submitPageTypeForm(id,subject) {
	var id = "pt-"+subject;
	var form_id = "form-page-type-"+subject;

	closeFFTT(id);	

	var form = document.forms[form_id];

	if(form != null) {
		var type = form.type.value;
		var url = ffurl + "edit_types&subaction=store&show=no&id="+id+"&title="+subject+"&type="+type;

        doHTTPRequest(subject,url)		
	} else {
		alert("could not store type!");
	}

}


function showPageDomainForm(subject) {
	var id = "pd-"+subject;
		
	var url = ffurl + "edit_domain&id="+id+"&title="+subject;
	
	showFFTT(id,url);
	
	// show it again, to ensure a correct positioning
	timerId = setTimeout('showFFTT("'+id+'","'+url+'"); clearTimeout(timerId); ',500);
	
}


function submitPageDomainForm(form_id,subject) {
	var id = "pd-"+subject;

	closeFFTT(id);	

	var form = document.forms[form_id];

	if(form != null) {
		var dom = form.domain.value;
		var url = ffurl + "edit_domain&subaction=store&show=no&id="+id+"&title="+subject+"&domain="+dom;

        doHTTPRequest(subject,url)		
	} else {
		alert("could not store domain!");
	}

}


function showPageRangeForm(subject) {
	var id = "pr-"+subject;
		
	var url = ffurl + "edit_range&id="+id+"&title="+subject;
	
	showFFTT(id,url);
	
	// show it again, to ensure a correct positioning
	timerId = setTimeout('showFFTT("'+id+'","'+url+'"); clearTimeout(timerId); ',500);
	
}


function submitPageRangeForm(form_id,subject) {
	var id = "pr-"+subject;

	closeFFTT(id);	

	var form = document.forms[form_id];

	if(form != null) {
		var range = form.range.value;
		var url = ffurl + "edit_range&subaction=store&show=no&id="+id+"&title="+subject+"&range="+range;

        doHTTPRequest(subject,url)		
	} else {
		alert("could not store domain!");
	}

}

function showPageInverseForm(subject) {
	var id = "pinv-"+subject;
		
	var url = ffurl + "edit_inverse&id="+id+"&title="+subject;
	
	showFFTT(id,url);
	
	// show it again, to ensure a correct positioning
	timerId = setTimeout('showFFTT("'+id+'","'+url+'"); clearTimeout(timerId); ',500);
	
}

function submitPageInverseForm(form_id,subject) {
	var id = "pinv-"+subject;

	closeFFTT(id);	

	var form = document.forms[form_id];

	if(form != null) {
		var inverse = form.range.value;
		var url = ffurl + "edit_inverse&subaction=store&show=no&id="+id+"&title="+subject+"&inverse="+inverse;
        doHTTPRequest(subject,url)		
	} else {
		alert("could not store inverse property!");
	}

}


function showPageSuperClassForm(subject) {
	var id = "psc-"+subject;
		
	var url = ffurl + "edit_superclasses&id="+id+"&title="+subject;
	
	showFFTT(id,url);
	
	// show it again, to ensure a correct positioning
	timerId = setTimeout('showFFTT("'+id+'","'+url+'"); clearTimeout(timerId); ',500);
	
}


function submitPageSuperClassForm(form_id,subject) {
	var id = "psc-"+subject;

	closeFFTT(id);	

	var form = document.forms[form_id];

	if(form != null) {
		var superclass = form.superclass.value;
		var url = ffurl + "edit_superclasses&subaction=store&show=no&id="+id+"&title="+subject+"&superclass="+superclass;

        doHTTPRequest(subject,url)		
	} else {
		alert("could not store superclass!");
	}

}

function showPageSuperPropertyForm(subject) {
	var id = "psp-"+subject;
		
	var url = ffurl + "edit_superproperties&id="+id+"&title="+subject;
	
	showFFTT(id,url);
	
	// show it again, to ensure a correct positioning
	timerId = setTimeout('showFFTT("'+id+'","'+url+'"); clearTimeout(timerId); ',500);
	
}


function submitPageSuperPropertyForm(form_id,subject) {
	var id = "psp-"+subject;

	closeFFTT(id);	

	var form = document.forms[form_id];

	if(form != null) {
		var superproperty = form.superproperty.value;
		var url = ffurl + "edit_superproperties&subaction=store&show=no&id="+id+"&title="+subject+"&superproperty="+superproperty;

        doHTTPRequest(subject,url)		
	} else {
		alert("could not store superproperty!");
	}

}


function doHTTPRequest(subject, url) {
	var http = getHTTPObject(); // We create the HTTP Object
	 
    http.open("GET", url , true);
	http.onreadystatechange = function() {
	    if(http.readyState == 4) {
		    updateContent(subject);
			updateReferences(subject);
		}
	}	
	http.send("");
}


function updateReferences(title) {
	var references = document.getElementById("p-references");
	
	var url = "references.jsp?title="+title;
	var http = getHTTPObject(); // We create the HTTP Object 
	
	http.open("GET", url , true);
	http.onreadystatechange = function() {
		if(http.readyState == 4) {
			references.innerHTML = http.responseText;
			initMenus();
		}
	}	
	http.send("");

}

function updateContent(title) {
	var content = document.getElementById("column-content");
	
	var url = "update_content.jsp?title="+title;
	var http = getHTTPObject(); // We create the HTTP Object 
	
	http.open("GET", url , true);
	http.onreadystatechange = function() {
		if(http.readyState == 4) {
			content.innerHTML = http.responseText;
		}
	}	
	http.send("");
	
	// invalidate tooltips
	var tooltips = document.getElementById('tooltips');
	tooltips.innerHTML = "";
}