// copyright by webmatze
// http://www.webmatze.de/webdesign/javascript/tooltips.htm
//
// modified for IkeWiki by Sebastian Schaffert, SRFG
// v0.2: support for XmlHttpRequest and AJAX-update of tooltip

var wmtt = null;

var tturl = "tooltip.jsp?title=";
var timerId = 0;

//document.onmousemove = updateWMTT;
document.addEventListener("mousemove",updateWMTT,true);

function updateWMTT() {
			
	x = getMouseX();
	y = getMouseY();

	if (wmtt != null) {
		if(x < window.innerWidth-wmtt.offsetWidth-20) {
			wmtt.style.left = (x + 20) + "px";
		} else {
			wmtt.style.left =  (window.innerWidth-wmtt.offsetWidth-20) + "px";
		}
		wmtt.style.top 	= (y + 20) + "px";
	}
}




function showWMTT(id) {
	wmtt = document.getElementById(id);
	if(wmtt == null) {
		wmtt = requestTooltip(id);
	}

	wmtt.style.left = "0";
	wmtt.style.top = "0";
	
	timerId = setTimeout('wmtt.style.display = "block"; clearTimeout(timerId); updateWMTT()',250);
	//wmtt.style.display = "block";
}

function showWMTTWithText(id,text) {
	wmtt = document.getElementById(id);
	if(wmtt == null) {
		wmtt = requestTooltipWithText(id,text);
	}

	wmtt.style.left = "0";
	wmtt.style.top = "0";
	
	timerId = setTimeout('wmtt.style.display = "block"; clearTimeout(timerId); updateWMTT()',250);
	//wmtt.style.display = "block";
}



function hideWMTT() {
	wmtt.style.display = "none";
	if(timerId > 0) {
		clearTimeout(timerId);
	}
}


function requestTooltip(id) {
	// tooltip ids always begin with tt- followed by the qualified title
	
	// extract qualified title
	var title = id.substring(3,id.length);
	
	var tooltips = document.getElementById('tooltips');
	
	
	var elem = document.createElement("div")	;
	elem.setAttribute("id",id);
	elem.setAttribute("class","tooltip");
	elem.innerHTML = " ";
	tooltips.appendChild(elem);

	var http = getHTTPObject(); // We create the HTTP Object 

	//http.open("GET", tturl + escape(title), true);
	http.open("GET", tturl + title, true);
	http.onreadystatechange = function() {
		if(http.readyState == 4) {
			//var stpos = http.responseText.search("<div");
			//elem.innerHTML = http.responseText.substring(stpos,http.responseText.length-1);
			//elem.appendChild(http.responseXML.getElementsByName("tooltip")[0]);
			elem.innerHTML = http.responseText;
		}
	}	
	http.send("");
	

	return elem;
}

function requestTooltipWithText(id,text) {
	// tooltip ids always begin with tt- followed by the qualified title
	
	// extract qualified title
	var title = id.substring(3,id.length);
	
	var tooltips = document.getElementById('tooltips');
	
	
	var elem = document.createElement("div")	;
	elem.setAttribute("id",id);
	elem.setAttribute("class","tooltip");
	
	var div = document.createElement("div");
	div.setAttribute("name","tooltip");
	elem.appendChild(div);
	
	div.innerHTML = text;
	
	tooltips.appendChild(elem);

	return elem;
}



function highlightLink(id) {
    var links = document.getElementsByName("link-"+id);
    
    for(var i = 0; i<links.length; i++) {
        links[i].style.backgroundColor = "yellow;";
    }
}

function unhighlightLink(id) {
    var links = document.getElementsByName("link-"+id);
    
    for(var i = 0; i<links.length; i++) {
        links[i].style.backgroundColor = "";
    }
}


