<%--
  *  Copyright (C) 2005
  *  Sebastian Schaffert and Rupert Westenthaler
  *  Salzburg Research Forschungsgesellschaft m.b.H.
  *
  *  IkeWiki is free software; you can redistribute it and/or
  *  modify it under the terms of the GNU Lesser General Public
  *  License as published by the Free Software Foundation; either
  *  version 2 of the License, or (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  *  Lesser General Public License for more details.
  *
  *  You should have received a copy of the GNU Lesser General Public
  *  License along with this library; if not, write to the
  *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  *  Boston, MA 02111-1307, USA.
  * 
--%>

<jsp:directive.page import="at.srfg.ikewiki.Main,at.srfg.ikewiki.render.*,at.srfg.ikewiki.layout.portlet.*,at.srfg.ikewiki.data.*"/>
<jsp:directive.page import="at.srfg.ikewiki.layout.*,at.srfg.ikewiki.layout.perspectives.*,at.srfg.ikewiki.layout.views.*,at.srfg.ikewiki.layout.viewitem.*"/>
<jsp:directive.page import="at.srfg.ikewiki.db.*"/>
<jsp:directive.page import="java.util.*"/>

<%!
	Main main;
%>
<%
    try {
	    main = Main.getInstance();
	} catch(DBException ex) {
		response.sendRedirect("setup.jsp");
		return;
	}
	// parse post data, if there is any
	RequestData parameters = main.parseRequestData(request);

	String userAgent = request.getHeader("user-agent");
	
	// if user agent is firefox v1.X, output XHTML
	if(userAgent != null && userAgent.contains("Firefox/1")) {
		response.setContentType("application/xhtml+xml");
	} else {
		response.setContentType("text/html");		
	}

	
	
    // read optional title parameter and set article_ns and article_title
    // to the namespace prefix and title of the article; if no title
    // parameter is given, use empty namespace prefix (mapping to "internal")
    // namespace and "FrontPage" title
	String req_title = parameters.get("title");

	String article_ns, article_title;
	if(req_title == null) {
 		article_ns    = "";
 		article_title = "FrontPage";
 	} else {
 		String[] components = req_title.replace(" ","_").split(":");
 		if(components.length == 2) {
	 		article_ns    = components[0];
	 		article_title = components[1];
	 	} else if(components.length == 1) {
	 		article_ns    = "";
	 		article_title = components[0];
	 	} else {
	 		article_ns    = "";
	 		article_title = "";
	 	}
 	}

	ViewArticlePerspective article;
	try {
		article=main.getViewArticlePerspective(article_ns,article_title);
	} catch(DBException ex) {
	    // in case FrontPage is not found, populate the database
		if(article_title.equals("FrontPage")) {
			article=new ViewArticlePerspective(main,main.populateDB());
		} else {
			article=null;
		}
	}

	//response.setContentType("text/xml");
	
	System.err.println("requested update for "+req_title);
	
	
	if(article != null && article.getContent().trim().length() > 0) { 
	   	String content = article.getContent(); 	
%>
		<%= content %>
<% 	
	} 
%>